/*
 * Copyright 1998-2007 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2007 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHOR(S) OR COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
#include <linux/version.h>
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
#include <linux/config.h>
#endif
#ifdef MODULE
#include <linux/module.h>
#endif
#include <linux/fb.h>
#include <linux/init.h>
#include <linux/pci.h>
#include <asm/uaccess.h>
#include <linux/proc_fs.h>

#include "viafbdev.h"

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
#include <video/fbcon.h>
#include <video/fbcon-cfb8.h>
#include <video/fbcon-cfb16.h>
#include <video/fbcon-cfb24.h>
#include <video/fbcon-cfb32.h>
#endif

#include "share.h"
#include "chip.h"
#include "debug.h"
#include "ioctl.h"
#include "accel.h"
#include "via_utility.h"
#include "hwcfig.h"
static struct fb_cmap viafb_256_colors = {
0,256,red256,green256,blue256,NULL
};
/*Add Accelerator ID for DirectFB*/
/*#define DirectFB*/

extern unsigned int get_memsize(void);
extern int setmode(int vmode_index,int hor_res,int ver_res,int video_bpp,
	int vmode_index1,int hor_res1,int ver_res1,int video_bpp1);
extern inline void lock_crt(void);
extern inline void unlock_crt(void);
extern write_reg(u8 index, u16 io_port, u8 data);
extern void write_reg_mask(u8 index, int io_port, u8 data, u8 mask);
extern void init_chip_info(void);
extern u8 read_reg(int io_port, u8 index);
extern void init_dac(int set_iga);
extern int get_pixclock(int hres, int vres, int vmode_refresh);
extern int get_refresh(int hres, int vres, int pixclock);
extern void update_device_setting(int hres, int vres, int bpp, int vmode_refresh,int flag);
extern unsigned long get_videobuf_addr(void);
extern int ioctl_get_viafb_info(u_long arg);
extern int ioctl_hotplug(int hres, int vres, int bpp);
extern int ioctl_get_tv_type(u_long arg);
extern void get_mmio_info(unsigned long *mmio_base, unsigned long *mmio_len);
extern int init_integrated_tv_regs(void);
extern void set_integrated_tv_size(u32 desired_hsize, u32 desired_vsize);

extern void crt_enable(void);
extern void crt_disable(void);
extern void dvi_enable(void);
extern void dvi_disable(void);
extern void tv_enable(void);
extern void tv_disable(void);
extern void lcd_enable(void);
extern void lcd_disable(void);
extern void set_iga_path(void);
extern void init_lcd_size(void);
extern void set_start_addr(void);

extern void tv_set_brightness(u32 value);
extern void tv_set_contrast(u32 value);
extern void tv_set_saturation(u32 value);
extern void tv_set_tint(u32 value);
extern void tv_set_ffilter(u32 state, u32 value);
extern void tv_set_position(u32 HPos, u32 VPos);
extern void tv_get_position(u32* HPos, u32* VPos);
extern void tv_set_adaptive_ffilter(u32 status, u32 value);
extern int tv_get_ffilter(int ffilter_type, int* ffilter_state);
extern void tv_get_support_standard(u32* support_state);
extern void tv_get_support_signal(u32* support_state);
extern int tv_get_max_size(void);
extern void tv_get_support_tuning_state(u32* support_state);
extern void tv_get_tuning_max_value(u32 item, u32* value);
extern void tv_get_support_setting_state(u32* support_state);
extern int check_macrovision_enabled(void);
extern void get_fb_info(unsigned int *fb_base, unsigned int *fb_len);
void memory_pitch_patch(struct fb_info *info);
void fill_var_timing_info(struct fb_var_screeninfo* var, int refresh, int mode_index);
    
int apply_device_setting(struct viafb_ioctl_setting ViaSetting, struct fb_info *info);
void retrieve_device_setting(struct viafb_ioctl_setting *ViaSetting);
int get_primary_device(void);
bool is_available_tv_system(int system_id);
bool is_available_tv_out_signal(int tv_out_signal);
void viafb_set_device(device_t active_dev);
void viafb_set_video_device(u32 video_dev_info);
void viafb_get_video_device(u32* video_dev_info);
void apply_second_mode_setting(struct fb_var_screeninfo* sec_var);
u8 gpio_i2c_read_lvds(struct lvds_setting_information *plvds_setting_info, struct lvds_chip_information *plvds_chip_info, u8 index);
void gpio_i2c_write_mask_lvds(struct lvds_setting_information *plvds_setting_info, struct lvds_chip_information *plvds_chip_info, IODATA io_data);
int __init viafb_setup(char *options);

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
extern void Init_Accel(void);
extern void Init_2D_Engine(void);
extern void Set_2D_Color_Depth(int);
extern void HWCursorInit(void);
extern void ShowHideHWCursor(struct fb_info *info, int Status);
extern int WaitEngineIdle(void);
#endif
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
extern int  soft_cursor(struct fb_info *info, struct fb_cursor *cursor);
#endif

int get_mode_index(int hres, int vres,int flag);
struct chip_information         chip_info;
struct crt_setting_information  crt_setting_info;
struct tv_setting_information   tv_setting_info;
struct tmds_setting_information tmds_setting_info;
struct lvds_setting_information lvds_setting_info;
struct lvds_setting_information lvds_setting_info2;

static struct fb_ops viafb_ops;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static struct viafb_info viafbinfo, viafbinfo1;
static struct display disp, disp1;

static struct { unsigned char red,green,blue,transp; } palette[256];
#else
static struct fb_info viafbinfo, viafbinfo1;
struct viafb_par parinfo, parinfo1;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,10)
#define viacursor  info->cursor
#else
struct fb_cursor viacursor;
#endif
#endif

static struct fb_var_screeninfo default_var;
static char * viafb_name = "Via";

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static int pseudo_pal[16];
#else
static u32 pseudo_pal[17];
#endif

/* video mode */
static char *mode = "640x480";
static char *mode1 = "640x480";
int bpp = 32,bpp1=32;
static int resMode = VIA_RES_640X480;

int memsize=0;
int second_size=0;
unsigned int second_offset=0;
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
    void __iomem *FB_MM;
#else
    unsigned long FB_MM;
#endif
int CRT_ON=1,DVI_ON=0,TV_ON=0,LCD_ON=0,LCD2_ON=0,SAMM_ON=0,dual_fb=0;
int VIDEO_ON_CRT=0, VIDEO_ON_DVI=0, VIDEO_ON_LCD=0, VIDEO_ON_TV=0;
unsigned int second_xres=640;
unsigned int second_yres=480;
unsigned int second_virtual_xres=0;
unsigned int second_virtual_yres=0;

int EPIA_DVI=STATE_OFF;
int LCDDualEdge=STATE_OFF;
int BusWidth=12;

/* Added for specifying active devices. */
char *active_dev = "";

/* Added for specifying video on devices. */
char *video_dev = "";

/* Added for specify lcd output port */
char *lcd_port = "";
char *dvi_port = "";

/* Add for determine hardware layout. */
int display_hardware_layout = HW_LAYOUT_LCD_DVI;

/* Keep the primary device, used in SAMM case. */
int primary_dev = None_Device;

/* Display Mode Information */
int  refresh = 60,refresh1=60;

/* TV Initilization */
int tv_level = 0;
int tv_system =  1; /*Clarification:This value will be convert to bitwise value 
                               *TVTYPE_NTSC in via_pci_probe */
int tv_out_signal = 5; /*This value will be convert to bitwise value 
                                    *TV_OUTPUT_COMPOSITE_SVIDEO in via_pci_probe */
int tv_dedotcrawl = 0;
long tv_ffilter= 0;
long tv_brightness = 0;
long tv_contrast = 0;
long tv_saturation = 0;
long tv_tint= 0;

/* Added for specify lcd output port */
char *tv_port = "";

long tv_pos_hor_current = TV_POS_DEFAULT_HOR_VALUE;
long tv_pos_ver_current = TV_POS_DEFAULT_VER_VALUE;

/* LCD Initilization */
int lcd_panel_id = LCD_PANEL_ID_MAXIMUM+1;
int lcd_dsp_method = LCD_EXPANDSION;
int lcd_mode = LCD_OPENLDI; /* OPENLDI || SPWG mode */

int DeviceStatus = CRT_Device;
int HotPlug_TV = 0, HotPlug = 0;
extern int HotPlug_Xres, HotPlug_Yres, HotPlug_bpp, HotPlug_refresh;

/* 2D Hardware Acceleration */
int accel = 0;

unsigned char CrReadByte(unsigned char byIndex)
{
    return read_reg(VIACR, byIndex);  
}

void CrWriteByte(unsigned char byIndex, unsigned char byValue)
{
        write_reg(byIndex, VIACR, byValue);
}

unsigned char SrReadByte(unsigned char byIndex)
{
    MMIO_OUT8( 0x3c4, byIndex);
    return MMIO_IN8(0x3c5);
}

void SrWriteByte(unsigned char byIndex, unsigned char byValue)
{
    MMIO_OUT8(0x3c4, byIndex);
    MMIO_OUT8(0x3c5, byValue);
}

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static void via_bmove (struct display *p, int sy, int sx,
                int dy, int dx, int height, int width)
{
}

static void via_clear_helper (int c, struct display *p,
                int sy, int sx, int height, int width)
{
}


#ifdef FBCON_HAS_CFB8
static void via_8bpp_clear (struct vc_data *conp, struct display *p,
                int sy, int sx, int height, int width)
{
    int c;
    c = attr_bgcol_ec(p,conp) & 0xFF;
    c |= c<<8;
    c |= c<<16;
    via_clear_helper(c,p,sy,sx,height,width);
}

static struct display_switch via_8bpp = {
    setup:      fbcon_cfb8_setup,
    bmove:      via_bmove,
    clear:      via_8bpp_clear,
    putc:       fbcon_cfb8_putc,
    putcs:      fbcon_cfb8_putcs,
    revc:       fbcon_cfb8_revc,
    clear_margins:  fbcon_cfb8_clear_margins,
    fontwidthmask:  FONTWIDTH (4) | FONTWIDTH (8) | FONTWIDTH (12) | FONTWIDTH (16)
};
#endif
#ifdef FBCON_HAS_CFB16
static void via_16bpp_clear (struct vc_data *conp, struct display *p,
                int sy, int sx, int height, int width)
{
    int c;
    c = ((u16*)p->dispsw_data)[attr_bgcol_ec(p,conp)];
    c = c | c<<16;
    via_clear_helper(c,p,sy,sx,height,width);
}
static struct display_switch via_16bpp = {
    setup:      fbcon_cfb16_setup,
    bmove:      via_bmove,
    clear:      via_16bpp_clear,
    putc:       fbcon_cfb16_putc,
    putcs:      fbcon_cfb16_putcs,
    revc:       fbcon_cfb16_revc,
    clear_margins:  fbcon_cfb16_clear_margins,
    fontwidthmask:  FONTWIDTH (4) | FONTWIDTH (8) | FONTWIDTH (12) | FONTWIDTH (16)
};
#endif
#ifdef FBCON_HAS_CFB32
static void via_32bpp_clear (struct vc_data *conp, struct display *p,
                int sy, int sx, int height, int width)
{
    int c;
    c = ((u32*)p->dispsw_data)[attr_bgcol_ec(p,conp)];
    via_clear_helper(c,p,sy,sx,height,width);
}
static struct display_switch via_32bpp = {
    setup:      fbcon_cfb32_setup,
    bmove:      via_bmove,
    clear:      via_32bpp_clear,
    putc:       fbcon_cfb32_putc,
    putcs:      fbcon_cfb32_putcs,
    revc:       fbcon_cfb32_revc,
    clear_margins:  fbcon_cfb32_clear_margins,
    fontwidthmask:  FONTWIDTH (4) | FONTWIDTH (8) | FONTWIDTH (12) | FONTWIDTH (16)
};
#endif

/* Fill in fix */
static int via_encode_fix(struct fb_fix_screeninfo *fix,
                  const void *par,
                  struct fb_info_gen *info)
{
    struct viafb_info * i = (struct viafb_info *)info;
    struct viafb_par * p = (struct viafb_par *)par;

    DEBUG_MSG(KERN_INFO "via_encode_fix!\n" );

    memset(fix, 0, sizeof(struct fb_fix_screeninfo));
    strcpy(fix->id,viafb_name);

    fix->smem_start = i->fbmem;
    fix->smem_len = i->memsize;

    fix->type = FB_TYPE_PACKED_PIXELS;
    fix->type_aux = 0;

    fix->visual = p->bpp==8 ? FB_VISUAL_PSEUDOCOLOR:FB_VISUAL_TRUECOLOR;

    fix->xpanstep = fix->ywrapstep = 0;
    fix->ypanstep = 1;
    fix->line_length = p->linelength;
    fix->mmio_start = i->mmio_base;
    fix->mmio_len = i->mmio_len;

/* Add Accelerator ID for DirectFB */
#ifdef DirectFB
    fix->accel = FB_ACCEL_VIA_UNICHROME;
#else
    fix->accel = FB_ACCEL_NONE;
#endif    

    return 0;
}

/* Fill in par from var */
static int via_decode_var(const struct fb_var_screeninfo *var,
                  void *par,
                  struct fb_info_gen *info)
{
    struct viafb_par * p = (struct viafb_par *)par;
    struct viafb_info * i = (struct viafb_info *)info;
    int vres,vfront,vback,vsync;
    int vmode_index;

    DEBUG_MSG(KERN_INFO "via_decode_var!\n" );
    vmode_index = get_mode_index(var->xres, var->yres,0);
    if (vmode_index == VIA_RES_INVALID)
    {
        DEBUG_MSG(KERN_INFO "viafb: Mode %dx%dx%d not supported!!\n", var->xres, var->yres, var->bits_per_pixel);
        return -EINVAL;
    }

    p->var = *var;
    p->bpp = var->bits_per_pixel;

    if (p->bpp == 24 )
        p->bpp = 32;

    p->linelength = var->xres_virtual * p->bpp/8;

    switch (p->bpp) {
        case 8:
            p->var.red.offset = 0;
            p->var.green.offset = 0;
            p->var.blue.offset = 0;
            p->var.red.length = 6;
            p->var.green.length = 6;
            p->var.blue.length = 6;
            break;
        case 16:
            p->var.red.offset = 11;
            p->var.green.offset = 5;
            p->var.blue.offset = 0;
            p->var.red.length = 5;
            p->var.green.length = 6;
            p->var.blue.length = 5;
            break;
        case 32:
            p->var.red.offset = 16;
            p->var.green.offset = 8;
            p->var.blue.offset = 0;
            p->var.red.length = 8;
            p->var.green.length = 8;
            p->var.blue.length = 8;
            break;
        default:
            return -EINVAL;
    }

    /* convert from picoseconds to MHz */
    refresh= get_refresh(var->xres, var->yres, var->pixclock);
    p->vclk = 1000000/var->pixclock;


    if (p->bpp == 32)
        p->vclk *=2;

    p->hres = var->xres;
    vres = p->vres = var->yres;

    /* See if requested resolution fits in available memory */
    if (p->hres * p->vres * p->bpp/8 > i->memsize) {
        return -EINVAL;
    }

    vfront = var->upper_margin;
    vback = var->lower_margin;
    vsync = var->vsync_len;

    /* Compute horizontal and vertical VGA CRTC timing values */
    if (var->vmode & FB_VMODE_INTERLACED) {
        vres /= 2;
        vfront /=2;
        vback /=2;
        vsync /=2;
    }

    if (var->vmode & FB_VMODE_DOUBLE) {
        vres *= 2;
        vfront *=2;
        vback *=2;
        vsync *=2;
    }

    p->htotal = (p->hres + var->left_margin + var->right_margin + var->hsync_len)/8 - 10;
    p->hdispend = p->hres/8 - 1;
    p->hsyncstart = (p->hres + var->right_margin)/8;
    p->hsyncend = var->hsync_len/8;
    p->hblankstart = p->hdispend + 1;
    p->hblankend = p->htotal + 5;

    p->vtotal = vres + vfront + vback + vsync - 2;
    p->vdispend = vres - 1;
    p->vsyncstart = vres + vback;
    p->vsyncend = vsync;
    p->vblankstart = vres;
    p->vblankend = p->vtotal + 2;

    return 0;
}


/* Fill in var from info */
static int via_encode_var(struct fb_var_screeninfo *var,
                  const void *par,
                  struct fb_info_gen *info)
{
    struct viafb_par * p = (struct viafb_par *)par;

    DEBUG_MSG(KERN_INFO "via_encode_var!\n" );
    *var = p->var;
    var->bits_per_pixel = p->bpp;

    return 0;
}

/* Fill in par from hardware */
static void via_get_par(void *par, struct fb_info_gen *info)
{
    struct viafb_par * p = (struct viafb_par *)par;
    struct viafb_info * i = (struct viafb_info *)info;

    DEBUG_MSG(KERN_INFO "via_get_par!\n" );
    *p = i->currentmode;
}

/* Pan the display */
static int via_pan_display(const struct fb_var_screeninfo *var,
                   struct fb_info_gen *info)
{
    unsigned int offset;
    struct viafb_info * i = (struct viafb_info *)info;

    DEBUG_MSG(KERN_INFO "via_pan_display!\n" );
    #if 0
    offset = (var->xoffset + (var->yoffset * var->xres))
            * var->bits_per_pixel/32;
    i->currentmode.var.xoffset = var->xoffset;
    i->currentmode.var.yoffset = var->yoffset;
		#endif
    
    /* Enable pan display function in viafb on cle266 and cn400 platform 
       add by tzp 20041010 ,for flip i bp frame, set register   
       1. Command hw to wait until engine idle
       2. Command hw to wait until display end
       3. Update start address */
    if(chip_info.gfx_chip_name == UNICHROME_CLE266 || chip_info.gfx_chip_name == UNICHROME_P880)
    {
       offset = (var->xoffset + (var->yoffset * var->xres)) * var->bits_per_pixel/16;
   
       i->currentmode.var.xoffset = var->xoffset;
       i->currentmode.var.yoffset = var->yoffset;
   
       write_reg_mask(0x48,0x3d4,((offset>>24) & 0x3),0x3);
       write_reg_mask(0x34,0x3d4,((offset>>16) & 0xff),0xff);
       write_reg_mask(0x0c,0x3d4,((offset>>8) & 0xff),0xff);
       write_reg_mask(0x0d,0x3d4,(offset & 0xff),0xff);
    }

    return 0;
}

/* Set the hardware from par */
static void via_set_par(const void *par, struct fb_info_gen *info)
{
    int vmode_index = 0;
    int vmode_index1 = 0;
    struct viafb_par * p = (struct viafb_par *)par;
    struct viafb_info * i = (struct viafb_info *)info;

    DEBUG_MSG(KERN_INFO "via_set_par!\n" );
    i->currentmode = *p;

    update_device_setting(i->currentmode.hres, i->currentmode.vres, i->currentmode.bpp, refresh,0);

    vmode_index = get_mode_index(i->currentmode.hres, i->currentmode.vres,0);
    DEBUG_MSG(KERN_INFO "->index=%d\n", vmode_index );
	   
    if(SAMM_ON==1)
    {
        DEBUG_MSG(KERN_INFO "second_xres=%d, second_yres=%d, bpp=%d\n",second_xres, second_yres, bpp1);
        vmode_index1 = get_mode_index(second_xres, second_yres,1);
        DEBUG_MSG(KERN_INFO "->SAMM_ON: index=%d\n", vmode_index1 );

	    update_device_setting(second_xres, second_yres, bpp1, refresh1,1);
    }
    if (vmode_index != VIA_RES_INVALID)
    {
        setmode(vmode_index,i->currentmode.hres,i->currentmode.vres,i->currentmode.bpp,
			vmode_index1,second_xres, second_yres, bpp1);
        via_pan_display(&p->var,info);
        bpp=i->currentmode.bpp;
    }
}

/* Get value of one color register */
static int via_getcolreg(unsigned regno, unsigned *red,
                 unsigned *green, unsigned *blue,
                 unsigned *transp, struct fb_info *info)
{
    struct viafb_info * i = (struct viafb_info *)info;
    int m = i->currentmode.bpp==8?256:16;

    DEBUG_MSG(KERN_INFO "via_getcolreg!\n" );
    if (regno >= m)
        return 1;

    *red = palette[regno].red;
    *green = palette[regno].green;
    *blue = palette[regno].blue;
    *transp = palette[regno].transp;

    return 0;
}

/* Set one color register */
static int via_setcolreg(unsigned regno, unsigned red, unsigned green,
                 unsigned blue, unsigned transp,
                 struct fb_info *info)
{
    struct viafb_info * i = (struct viafb_info *)info;
    int bpp = i->currentmode.bpp;
    u8 sr15,sr1a,sr1b,cr67,cr6a;

    DEBUG_MSG(KERN_INFO "via_setcolreg!\n" );
    /* The kernle don't have 256color cmap, so it can't pass regno>=256 */
    if(regno >= 16)
        return 1;

    palette[regno].red = red;
    palette[regno].green = green;
    palette[regno].blue = blue;
    palette[regno].transp = transp;

    if (bpp==8) {
        outb(0x1A,0x3C4);
        sr1a = inb(0x3C5);
        outb(0x1B,0x3C4);
        sr1b = inb(0x3C5);
        outb(0x67,0x3D4);
        cr67 = inb(0x3D5);
        outb(0x6A,0x3D4);
        cr6a = inb(0x3D5);

        outb(0x1A,0x3C4);
        outb(sr1a | 0x01,0x3C5); /* Map the 3C6/7/8/9 to the IGA2 */
        outb(0x1B,0x3C4);
        outb(sr1b | 0x80,0x3C5); /* Second Display Engine colck always on */
        outb(0x67,0x3D4);
        outb(cr67 & 0x3F,0x3D5); /* Second Display Color Depth 8 */
        outb(0x6A,0x3D4);
        outb(cr6a & 0xBF,0x3D5); /* Second Display Channel Reset CR6A[6]) */
        outb(cr6a | 0x80,0x3D5); /* Second Display Channel Enable CR6A[7] */
        outb(cr6a | 0x40,0x3D5); /* Second Display Channel stop reset) */
        
        outb(0xFF,0x3c6); /* Bit mask of palette */
        outb(regno,0x3C8); /* Write one register of IGA2 */   
        outb(red>>10,0x3C9);
        outb(green>>10,0x3C9);
        outb(blue>>10,0x3C9);

        outb(0x1A,0x3C4);
        outb(sr1a & 0xFE,0x3C5); /* Map the 3C6/7/8/9 to the IGA1 */    

        outb(0xFF,0x3c6); /* Bit mask of palette */
        outb(regno,0x3C8); /* Write one register of IGA1 */
        outb(red>>10,0x3C9);
        outb(green>>10,0x3C9);
        outb(blue>>10,0x3C9);

        outb(0x1A,0x3C4);
        outb(sr1a,0x3C5);
        outb(0x1B,0x3C4);
        outb(sr1b,0x3C5);
        outb(0x67,0x3D4);
        outb(cr67,0x3D5);
        outb(0x6A,0x3D4);
        outb(cr6a,0x3D5);
    } else
    if (bpp == 16)          /* RGB 565 */
            ((u16*)info->pseudo_palette)[regno] = (red & 0xF800) |
            ((green & 0xFC00) >> 5) | ((blue & 0xF800) >> 11);
    else
    if (bpp == 32)      /* ARGB 8888 */
        ((u32*)info->pseudo_palette)[regno] =
            ((transp & 0xFF00) <<16)    |
            ((red & 0xFF00) << 8)       |
            ((green & 0xFF00))      |
            ((blue & 0xFF00)>>8);

    return 0;
}

/* write 256 color registers one time */
static int via_loadpalette(struct fb_cmap *cmap) {
    u32 len = cmap->len;
    u32 i;
    u16 *pred = cmap->red;
    u16 *pgreen = cmap->green;
    u16 *pblue = cmap->blue;
    u16 *ptransp = cmap->transp;
    u8 sr1a, sr15, sr1b, cr67, cr6a;
    if(len > 256) return 1;
     
    outb(0x1A,0x3C4);
    sr1a = inb(0x3C5);
    outb(0x1B,0x3C4);
    sr1b = inb(0x3C5);
    outb(0x67,0x3D4);
    cr67 = inb(0x3D5);
    outb(0x6A,0x3D4);
    cr6a = inb(0x3D5);

    outb(0x1A,0x3C4);
    outb(sr1a | 0x01,0x3C5); /* Map the 3C6/7/8/9 to the IGA2 */
    outb(0x1B,0x3C4);
    outb(sr1b | 0x80,0x3C5); /* Second Display Engine colck always on */
    outb(0x67,0x3D4);
    outb(cr67 & 0x3F,0x3D5); /* Second Display Color Depth 8 */
    outb(0x6A,0x3D4);
    outb(cr6a & 0xBF,0x3D5); /* Second Display Channel Reset CR6A[6]) */
    outb(cr6a | 0x80,0x3D5); /* Second Display Channel Enable CR6A[7] */
    outb(cr6a | 0x40,0x3D5); /* Second Display Channel stop reset) */
    
    outb(0xFF,0x3c6); /* Bit mask of palette */
    outb(0x00,0x3C8);
    for (i = 0; i < len; i++)
    {   outb((*(pred+i))>>10,0x3C9);
        outb((*(pgreen+i))>>10,0x3C9);
        outb((*(pblue+i))>>10,0x3C9);
    }

    outb(0x1A,0x3C4);
    outb(sr1a & 0xFE,0x3C5); /* Map the 3C6/7/8/9 to the IGA1 */    

    outb(0xFF,0x3c6); /* Bit mask of palette */
    outb(0x00,0x3C8);
    for (i = 0; i < len; i++)
    {   outb((*(pred+i))>>10,0x3C9);
        outb((*(pgreen+i))>>10,0x3C9);
        outb((*(pblue+i))>>10,0x3C9);
    } 

    outb(0x1A,0x3C4);
    outb(sr1a,0x3C5);
    outb(0x1B,0x3C4);
    outb(sr1b,0x3C5);
    outb(0x67,0x3D4);
    outb(cr67,0x3D5);
    outb(0x6A,0x3D4);
    outb(cr6a,0x3D5);
return 0;
}

/* blank screen */
static int via_blank(int blank_mode, struct fb_info_gen *info)
{
    DEBUG_MSG(KERN_INFO "via_blank!\n" );
    /* clear DPMS setting */

    switch (blank_mode) {
    case VESA_NO_BLANKING:
        /* Screen: On, HSync: On, VSync: On */
        write_reg_mask(CR36, VIACR, 0x00, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_HSYNC_SUSPEND:
        /* Screen: Off, HSync: Off, VSync: On */
        write_reg_mask(CR36, VIACR, 0x10, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_VSYNC_SUSPEND:
        /* Screen: Off, HSync: On, VSync: Off */
        write_reg_mask(CR36, VIACR, 0x20, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_POWERDOWN:
        /* Screen: Off, HSync: Off, VSync: Off */
        write_reg_mask(CR36, VIACR, 0x30, BIT4+BIT5);   /* control CRT monitor power management */
        break;
        }


    return 0;
}

/* Set display switch used by console */
static void via_set_disp(const void *par, struct display *disp,
                 struct fb_info_gen *info)
{
    struct viafb_info * i = (struct viafb_info *)info;
    struct fb_info * ii = (struct fb_info *)info;
    struct viafb_par * p = (struct viafb_par *)par;
    int isaccel = 0;

    DEBUG_MSG(KERN_INFO "via_set_disp!\n" );
    disp->screen_base = (char *)i->fbmem_virt;

#ifdef FBCON_HAS_CFB8
    if (p->bpp == 8 ) {
        if (isaccel)
            disp->dispsw = &via_8bpp;
        else
            disp->dispsw = &fbcon_cfb8;
    } else
#endif
#ifdef FBCON_HAS_CFB16
    if (p->bpp == 16) {
        if (isaccel){
            disp->dispsw = &via_16bpp;
    }else
            disp->dispsw = &fbcon_cfb16;

        disp->dispsw_data =ii->pseudo_palette;  /* console palette */
    } else
#endif
#ifdef FBCON_HAS_CFB32
    if (p->bpp == 32) {
        if (isaccel)
            disp->dispsw = &via_32bpp;
        else
            disp->dispsw = &fbcon_cfb32;
        disp->dispsw_data =ii->pseudo_palette;  /* console palette */
    } else
#endif
    disp->dispsw = &fbcon_dummy;

    /* Fix monitor scroll would be slowly. */
    disp->scrollmode = SCROLL_YREDRAW;

}

static int viafb_ioctl(struct inode *inode, struct file *file, u_int cmd,
               u_long arg, int con, struct fb_info_gen *info)
{
    struct viafb_info * i = (struct viafb_info *)info;
    struct viafb_ioctl_info viainfo;
    struct viafb_ioctl_mode viamode;
    struct viafb_ioctl_samm viasamm;
    struct viafb_driver_version driver_version;
    struct fb_var_screeninfo sec_var;
    POSITIONVALUE SetViewSizeValue, SetViewPosValue;	 

    /* Only for case "SET_DEVICE_INFO" and "GET_DEVICE_INFO" */
    struct viafb_ioctl_setting viafb_setting;  
    memset(&viafb_setting,0,sizeof(viafb_setting));
	
    u32 __user  *argp = (u32 __user *)arg;
    u32         gpu32 = 0,ss;
    device_t active_dev;
    u32 video_dev_info = 0;
    ss = sizeof(active_dev);
    memset(&active_dev,0,ss);

    DEBUG_MSG(KERN_INFO "viafb_ioctl: 0x%X !!\n", cmd);
    DEBUG_MSG(KERN_INFO "viafb_ioctl: 0x%X !!\n", cmd);

    switch (cmd)
	{ 
        case VIAFB_GET_CHIP_INFO: /* struct chip_information        chip_info ; */
            if(copy_to_user((void __user *)arg, &chip_info, sizeof(chip_info)))
                return -EFAULT;
            break;
	
        case VIAFB_GET_INFO_SIZE:
            return put_user(sizeof(viainfo), argp);
        case VIAFB_GET_INFO:
            return ioctl_get_viafb_info(arg);
        case VIAFB_HOTPLUG:
            return put_user((u32)ioctl_hotplug(i->currentmode.hres, i->currentmode.vres, i->currentmode.bpp), argp);
            break;
        case VIAFB_SET_HOTPLUG_FLAG:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            HotPlug = (gpu32) ? 1 : 0;
            break;
        case VIAFB_GET_RESOLUTION:
            viamode.xres = (u32)HotPlug_Xres;
            viamode.yres = (u32)HotPlug_Yres;
            viamode.refresh = (u32)HotPlug_refresh;
            viamode.bpp = (u32)HotPlug_bpp;
            if(SAMM_ON==1){
                viamode.xres_sec=second_xres;
                viamode.yres_sec=second_yres;
                viamode.virtual_xres_sec = second_virtual_xres;
                viamode.virtual_yres_sec = second_virtual_yres;
                viamode.refresh_sec=refresh1;
                viamode.bpp_sec=bpp1;
            }else{
                viamode.xres_sec=0;
                viamode.yres_sec=0;
                viamode.virtual_xres_sec = 0;
                viamode.virtual_yres_sec = 0;
                viamode.refresh_sec=0;
                viamode.bpp_sec=0;
            }
            if(copy_to_user((void __user *)arg, &viamode, sizeof(viamode))) {
                return -EFAULT;
            }
            break;
        case VIAFB_GET_TV_TYPE:
            return ioctl_get_tv_type(arg);
        case VIAFB_GET_SAMM_INFO:
            viasamm.samm_status= SAMM_ON; /* MB0 */
            if(SAMM_ON==1){
                if(dual_fb) 
                {
                    viasamm.size_prim = viafbinfo.memsize;
                    viasamm.size_sec = viafbinfo1.memsize;
                }
                else 
                {
                    if(second_size)
                    {
                        viasamm.size_prim=viafbinfo.memsize - second_size*1024*1024;
                        viasamm.size_sec=second_size*1024*1024;
                    }
		    else
		    {
                        viasamm.size_prim=viafbinfo.memsize>>1;
                        viasamm.size_sec=viafbinfo.memsize>>1;
		     }
                } 
                viasamm.mem_base=viafbinfo.fbmem;
                viasamm.offset_sec=second_offset;
            }else{
                viasamm.size_prim=viafbinfo.memsize;
                viasamm.size_sec=0;
                viasamm.mem_base=viafbinfo.fbmem;
                viasamm.offset_sec=0;
            }
           
            if(copy_to_user((void __user *)arg, &viasamm, sizeof(viasamm))) 
                return -EFAULT;

            break;
        case VIAFB_TURN_ON_OUTPUT_DEVICE:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            if (gpu32 & CRT_Device)
                crt_enable();
            if (gpu32 & DVI_Device)
                dvi_enable();
            if (gpu32 & TV_Device)
                tv_enable();
            if (gpu32 & LCD_Device)
                lcd_enable();
            break;
        case VIAFB_TURN_OFF_OUTPUT_DEVICE:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            if (gpu32 & CRT_Device)
                crt_disable();
            if (gpu32 & DVI_Device)
                dvi_disable();
            if (gpu32 & TV_Device)
                tv_disable();
            if (gpu32 & LCD_Device)
                lcd_disable();
            break;
        case VIAFB_SET_DEVICE:
            if (copy_from_user(&active_dev, (void *)argp,ss))
            {
                return -EFAULT;
            }
            if(check_macrovision_enabled() && (active_dev.tv != TV_ON || TV_ON))
                break;
            viafb_set_device(active_dev);
            via_set_par((void*)(&i->currentmode),info);
            break;
        case VIAFB_GET_DEVICE:
            active_dev.crt = CRT_ON;
            active_dev.dvi = DVI_ON;
            active_dev.tv = TV_ON;
            active_dev.lcd = LCD_ON;            
            active_dev.lcd2 = LCD2_ON;
            active_dev.samm = SAMM_ON;
            active_dev.primary_dev = primary_dev;

            active_dev.tv_system = tv_system;
            active_dev.tv_level = tv_level;
            active_dev.tv_out_sig = tv_out_signal;
            active_dev.tv_dedotcrawl = tv_dedotcrawl;

            active_dev.lcd_dsp_cent = lcd_dsp_method; 
            active_dev.lcd_panel_id = lcd_panel_id;
            active_dev.lcd_mode = lcd_mode;

            active_dev.xres = HotPlug_Xres;
            active_dev.yres = HotPlug_Yres;

            active_dev.xres1 = second_xres;
            active_dev.yres1 = second_yres;
      
            active_dev.bpp = bpp;
            active_dev.bpp1 = bpp1;
            active_dev.refresh = refresh;
            active_dev.refresh1 = refresh1;
            
            active_dev.epia_dvi=EPIA_DVI;
            active_dev.lcd_dual_edge=LCDDualEdge;
            active_dev.bus_width=BusWidth;

            if(copy_to_user((void __user *)arg, &active_dev, sizeof(device_t))) 
                return -EFAULT;
            break;
        case VIAFB_SET_TV_FFILTER:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_ffilter(STATE_ON, gpu32);
            break;
        case VIAFB_SET_TV_COLOR_DEFAULT:
        {
            u32 def_val[4];
            tv_set_brightness(tv_setting_info.DefaultBrightness);
            tv_set_contrast(tv_setting_info.DefaultContrast);
            tv_set_saturation(tv_setting_info.DefaultSaturation);
            tv_set_tint(tv_setting_info.DefaultTINT);
            def_val[0] = tv_setting_info.DefaultBrightness;
            def_val[1] = tv_setting_info.DefaultContrast;
            def_val[2] = tv_setting_info.DefaultSaturation;
            def_val[3] = tv_setting_info.DefaultTINT;
            if(copy_to_user((void __user *)arg, &def_val, sizeof(u32)*4)) 
                return -EFAULT;
            break;
        }
        case VIAFB_SET_TV_BRIGHTNESS:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_brightness(gpu32);
            break;
        case VIAFB_SET_TV_CONTRAST:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_contrast(gpu32);
            break;
        case VIAFB_SET_TV_SATURATION:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_saturation(gpu32);
            break;
        case VIAFB_SET_TV_TINT:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_tint(gpu32);
            break;

        /* Add for getting driver version. */
        case VIAFB_GET_DRIVER_VERSION:
            driver_version.iMajorNum = VERSION_MAJOR;            
            driver_version.iKernelNum = VERSION_KERNEL;
            driver_version.iOSNum = VERSION_OS;
            driver_version.iMinorNum = VERSION_MINOR;
            
            if(copy_to_user((void __user *)arg, &driver_version, sizeof(driver_version)))
            {
                return -EFAULT;
            }
            
            break;

        /* Set and apply CRT,DVI,LCD,TV's setting info. */ 
        case VIAFB_SET_DEVICE_INFO:
            if(copy_from_user(&viafb_setting, (void *)argp,sizeof(viafb_setting)))
            {
                return -EFAULT;
            }
           if(check_macrovision_enabled() && (((viafb_setting.device_status & TV_Device) >> 2)!= TV_ON || TV_ON))
                break;
            if(apply_device_setting(viafb_setting, info)<0)
            {
                return -EINVAL;
            }
  
            break;

        case VIAFB_SET_SECOND_MODE:
            if(copy_from_user(&sec_var, (void *)argp,sizeof(sec_var)))
            {
                return -EFAULT;
            }
            apply_second_mode_setting(&sec_var);
            break;            

        /* Get current VIA framebuffer device setting info. */ 
        case VIAFB_GET_DEVICE_INFO:

            retrieve_device_setting(&viafb_setting);

            if(copy_to_user((void __user *)arg, &viafb_setting, sizeof(viafb_setting)))
            {
                return -EFAULT;
            }
            break;
        case VIAFB_SET_TV_POSITION:
            if(copy_from_user(&SetViewPosValue, (void *)argp,sizeof(POSITIONVALUE))) {
                return -EFAULT;
            }

            if (SetViewPosValue.dwX == 0xFFFF && SetViewPosValue.dwY == 0xFFFF)
            {
                 SetViewPosValue.dwX = tv_setting_info.DefaultPositionH;
                 SetViewPosValue.dwY = tv_setting_info.DefaultPositionV;
            }
				
            tv_set_position(SetViewPosValue.dwX,SetViewPosValue.dwY);
            DEBUG_MSG(KERN_INFO "tv_set_position:  tv_setting_info.level=%d\n",  tv_setting_info.level);	 
				 
            break;
        case VIAFB_SET_TV_SIZE:
            if(copy_from_user(&SetViewSizeValue, (void *)argp,sizeof(POSITIONVALUE))) {
                return -EFAULT;
            }

            if (SetViewSizeValue.dwX == 0xFFFF && SetViewSizeValue.dwY == 0xFFFF)
            {
                SetViewSizeValue.dwX = tv_setting_info.DefaultScalH + 1;
                SetViewSizeValue.dwY = tv_setting_info.DefaultScalV + 1;
                tv_setting_info.CurrentScalH= tv_setting_info.DefaultScalH;
                tv_setting_info.CurrentScalV= tv_setting_info.DefaultScalV;
            }
				
            tv_set_size(SetViewSizeValue.dwX,SetViewSizeValue.dwY);	
            DEBUG_MSG(KERN_INFO "tv_set_size:  tv_setting_info.level=%d\n",  tv_setting_info.level);	 
		
            break;		
        case VIAFB_SET_VIDEO_DEVICE:
            get_user(video_dev_info, argp);
            viafb_set_video_device(video_dev_info);
            break;
        case VIAFB_GET_VIDEO_DEVICE:
            viafb_get_video_device(&video_dev_info);
            if (put_user(video_dev_info, argp))
            {
               return -EFAULT; 
            }
            break;

        default:
            return -EINVAL;
        }

    return 0;
}

static struct fbgen_hwswitch via_hwswitch = {
    NULL, /* detect not needed */
    via_encode_fix,
    via_decode_var,
    via_encode_var,
    via_get_par,
    via_set_par,
    via_getcolreg,
    via_setcolreg,
    via_pan_display,
    via_blank,
    via_set_disp
};
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
static int
viafb_get_fix(struct fb_fix_screeninfo *fix, struct fb_info *info)
{
    /* Modified for dual-fb. */
    struct viafb_par *ppar;
    ppar = info->par;

    DEBUG_MSG(KERN_INFO "viafb_get_fix!\n");

    memset(fix, 0, sizeof(struct fb_fix_screeninfo));
    strcpy(fix->id, viafb_name);

    fix->smem_start = ppar->fbmem;
    fix->smem_len = ppar->fbmem_free;

    fix->type = FB_TYPE_PACKED_PIXELS;
    fix->type_aux = 0;

    fix->visual = ppar->bpp==8 ? FB_VISUAL_PSEUDOCOLOR:FB_VISUAL_TRUECOLOR;

    fix->xpanstep = fix->ywrapstep = 0;
    fix->ypanstep = 1;
    fix->line_length = ppar->linelength;

    fix->mmio_start = ppar->mmio_base;
    fix->mmio_len = ppar->mmio_len;

    if(accel)
        fix->accel = FB_ACCEL_VIA_UNICHROME;
    else
        fix->accel = FB_ACCEL_NONE;

    return 0;
}

static int viafb_open(struct fb_info *info, int user)
{
    DEBUG_MSG(KERN_INFO "viafb_open!\n");
    return 0;
}

static int viafb_release(struct fb_info *info, int user)
{
    DEBUG_MSG(KERN_INFO "viafb_release!\n");
    return 0;
}

static int viafb_check_var(struct fb_var_screeninfo *var,
                           struct fb_info *info)
{
    int vres,vfront,vback,vsync;
    int vmode_index;
    /* Modified for dual-fb according. */
    struct viafb_par *ppar;
    ppar = info->par;

    DEBUG_MSG(KERN_INFO "viafb_check_var!\n");
    vmode_index = get_mode_index(var->xres, var->yres,0);
    if (vmode_index == VIA_RES_INVALID)
    {
        DEBUG_MSG(KERN_INFO "viafb: Mode %dx%dx%d not supported!!\n", var->xres, var->yres, var->bits_per_pixel);
        return -EINVAL;
    }
    /* convert from picoseconds to MHz */
    refresh = get_refresh(var->xres, var->yres, var->pixclock);
    if(24 == var->bits_per_pixel)
    {
        var->bits_per_pixel = 32;
    }
    if((var->xres_virtual * (var->bits_per_pixel>> 3)) & 0x1F)/* Is 32 bytes alignment? */
    {
        var->xres_virtual = (var->xres_virtual + 31) & ~31;/* 32 pixel alignment */
    }
    
    /* Fill var's time information according our table, or fbset will show wrong information */
    fill_var_timing_info(var, refresh, vmode_index);
    
    ppar->var = *var;
    ppar->bpp = var->bits_per_pixel;

    if (ppar->bpp == 24)
        ppar->bpp = 32;

    ppar->linelength = ((var->xres_virtual + 7) & ~7) * ppar->bpp/8;

    switch (ppar->bpp) {
        case 8:
            ppar->var.red.offset = 0;
            ppar->var.green.offset = 0;
            ppar->var.blue.offset = 0;
            ppar->var.red.length = 6;
            ppar->var.green.length = 6;
            ppar->var.blue.length = 6;
            break;
        case 16:
            ppar->var.red.offset = 11;
            ppar->var.green.offset = 5;
            ppar->var.blue.offset = 0;
            ppar->var.red.length = 5;
            ppar->var.green.length = 6;
            ppar->var.blue.length = 5;
            break;
        case 32:
            ppar->var.red.offset = 16;
            ppar->var.green.offset = 8;
            ppar->var.blue.offset = 0;
            ppar->var.red.length = 8;
            ppar->var.green.length = 8;
            ppar->var.blue.length = 8;
            break;
        default:
            return -EINVAL;
    }

    ppar->vclk = 1000000/var->pixclock;

    if (ppar->bpp == 32)
        ppar->vclk *=2;

    ppar->hres = var->xres;
    vres = ppar->vres = var->yres;

    /* See if requested resolution fits in available memory */
    if (ppar->hres * ppar->vres * ppar->bpp/8 > ppar->memsize) {
        return -EINVAL;
    }

    vfront = var->upper_margin;
    vback = var->lower_margin;
    vsync = var->vsync_len;

    /* Compute horizontal and vertical VGA CRTC timing values */
    if (var->vmode & FB_VMODE_INTERLACED) {
        vres /= 2;
        vfront /=2;
        vback /=2;
        vsync /=2;
    }

    if (var->vmode & FB_VMODE_DOUBLE) {
        vres *= 2;
        vfront *=2;
        vback *=2;
        vsync *=2;
    }

    ppar->htotal = (ppar->hres + var->left_margin + var->right_margin + var->hsync_len)/8 - 10;
    ppar->hdispend = ppar->hres/8 - 1;
    ppar->hsyncstart = (ppar->hres + var->right_margin)/8;
    ppar->hsyncend = var->hsync_len/8;
    ppar->hblankstart = ppar->hdispend + 1;
    ppar->hblankend = ppar->htotal + 5;

    ppar->vtotal = vres + vfront + vback + vsync - 2;
    ppar->vdispend = vres - 1;
    ppar->vsyncstart = vres + vback;
    ppar->vsyncend = vsync;
    ppar->vblankstart = vres;
    ppar->vblankend = ppar->vtotal + 2;

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,8)
    info->var = ppar->var;
#endif

    return 0;
}

static int viafb_set_par(struct fb_info *info)
{
    int vmode_index;
    int vmode_index1=0;

    DEBUG_MSG(KERN_INFO "viafb_set_par!\n");
    
    refresh = get_refresh(info->var.xres, info->var.yres, info->var.pixclock);

    update_device_setting(info->var.xres, info->var.yres, info->var.bits_per_pixel, refresh,0);

    vmode_index = get_mode_index(info->var.xres, info->var.yres,0);
    
    if(SAMM_ON==1)
    {
        DEBUG_MSG(KERN_INFO "second_xres=%d, second_yres=%d, bpp=%d\n",second_xres, second_yres, bpp1);
        vmode_index1 = get_mode_index(second_xres, second_yres,1);
        DEBUG_MSG(KERN_INFO "->SAMM_ON: index=%d\n", vmode_index1 );
           
        update_device_setting(second_xres, second_yres, bpp1, refresh1,1);
    }
    if (vmode_index != VIA_RES_INVALID)
    {
        setmode(vmode_index,info->var.xres, info->var.yres, info->var.bits_per_pixel,
            vmode_index1,second_xres,second_yres,bpp1);

        /* We should set memory offset according virtual_x */
        /* Fix me:put this function into setmode */
        memory_pitch_patch(info);
        
        viafb_check_var(&info->var, info);
        viafb_get_fix(&info->fix, info);

        bpp=info->var.bits_per_pixel;

        if(accel)
            Set_2D_Color_Depth(info->var.bits_per_pixel);
    }

    return 0;
}

static int
viafb_get_cmap_len(struct fb_var_screeninfo *var)
{
    DEBUG_MSG(KERN_INFO "viafb_get_cmap_len!\n" );

    return (var->bits_per_pixel == 8) ? 256 : 16;
}


/* Set one color register */
static int viafb_setcolreg(unsigned regno, unsigned red, unsigned green,
                 unsigned blue, unsigned transp,
                 struct fb_info *info)
{
    u8 sr1a,sr1b,cr67,cr6a,rev = 0, shift = 10;
    DEBUG_MSG(KERN_INFO "viafb_setcolreg!\n" );
    if(regno >= viafb_get_cmap_len(&info->var))
        return 1;
    if(UNICHROME_CLE266 == chip_info.gfx_chip_name)
    {
        /* Read PCI bus 0, dev 0, function 0, index 0xF6 to get chip rev. */
        outl(0x80000000 | (0xf6 & ~3), (unsigned long)0xCF8);
        rev = (inl((unsigned long)0xCFC) >> ((0xf6 & 3) * 8)) & 0xff;
    }
    switch(info->var.bits_per_pixel) {
        case 8:
            outb(0x1A,0x3C4);
            sr1a = inb(0x3C5);
            outb(0x1B,0x3C4);
            sr1b = inb(0x3C5);
            outb(0x67,0x3D4);
            cr67 = inb(0x3D5);
            outb(0x6A,0x3D4);
            cr6a = inb(0x3D5);

            outb(0x1A,0x3C4);
            outb(sr1a | 0x01,0x3C5); /* Map the 3C6/7/8/9 to the IGA2 */
            outb(0x1B,0x3C4);
            outb(sr1b | 0x80,0x3C5); /* Second Display Engine colck always on */
            outb(0x67,0x3D4);
            outb(cr67 & 0x3F,0x3D5); /* Second Display Color Depth 8 */
            outb(0x6A,0x3D4);
            outb(cr6a & 0xBF,0x3D5); /* Second Display Channel Reset CR6A[6]) */
            outb(cr6a | 0x80,0x3D5); /* Second Display Channel Enable CR6A[7] */
            outb(cr6a | 0x40,0x3D5); /* Second Display Channel stop reset) */
            
            outb(0xFF,0x3c6); /* Bit mask of palette */
            outb(regno,0x3C8); /* Write one register of IGA2 */ 
            if(UNICHROME_CLE266 == chip_info.gfx_chip_name && rev >= 15)
            {
                shift = 8;
                write_reg_mask(CR6A, VIACR, BIT5, BIT5);
                write_reg_mask(SR15, VIASR, BIT7, BIT7);
            }
            outb(red>>shift, 0x3C9);
            outb(green>>shift, 0x3C9);
            outb(blue>>shift, 0x3C9);

            outb(0x1A,0x3C4);
            outb(sr1a & 0xFE,0x3C5); /* Map the 3C6/7/8/9 to the IGA1 */    

            outb(0xFF,0x3c6); /* Bit mask of palette */
            outb(regno,0x3C8); /* Write one register of IGA1 */
            outb(red>>shift,0x3C9);
            outb(green>>shift,0x3C9);
            outb(blue>>shift,0x3C9);

            outb(0x1A,0x3C4);
            outb(sr1a,0x3C5);
            outb(0x1B,0x3C4);
            outb(sr1b,0x3C5);
            outb(0x67,0x3D4);
            outb(cr67,0x3D5);
            outb(0x6A,0x3D4);
            outb(cr6a,0x3D5);
            break;
        case 16:
            ((u32*)info->pseudo_palette)[regno] = (red & 0xF800) |
            ((green & 0xFC00) >> 5) | ((blue & 0xF800) >> 11);
            break;
        case 32:
            ((u32*)info->pseudo_palette)[regno] =
                ((transp & 0xFF00) << 16)   |
                ((red & 0xFF00) << 8)       |
                ((green & 0xFF00))          |
                ((blue & 0xFF00) >> 8);
            break;
    }

   return 0;

}

/*CALLED BY: fb_set_cmap */
/*           fb_set_var, pass 256 colors */
/*CALLED BY: fb_set_cmap */      
/*           fbcon_set_palette, pass 16 colors */
static int viafb_setcmap(struct fb_cmap *cmap, struct fb_info *info) {
    u32 len = cmap->len;
    u32 i;
    u16 *pred = cmap->red;
    u16 *pgreen = cmap->green;
    u16 *pblue = cmap->blue;
    u16 *ptransp = cmap->transp;
    u8 sr1a,sr1b,cr67,cr6a, rev = 0, shift = 10;
    if(len>256) return 1;
    if(UNICHROME_CLE266 == chip_info.gfx_chip_name)
    {
        /* Read PCI bus 0, dev 0, function 0, index 0xF6 to get chip rev. */
        outl(0x80000000 | (0xf6 & ~3), (unsigned long)0xCF8);
        rev = (inl((unsigned long)0xCFC) >> ((0xf6 & 3) * 8)) & 0xff;
    }
    switch(info->var.bits_per_pixel) {
        case 8:
        outb(0x1A,0x3C4);
        sr1a = inb(0x3C5);
        outb(0x1B,0x3C4);
        sr1b = inb(0x3C5);
        outb(0x67,0x3D4);
        cr67 = inb(0x3D5);
        outb(0x6A,0x3D4);
        cr6a = inb(0x3D5);

        outb(0x1A,0x3C4);
        outb(sr1a | 0x01,0x3C5); /* Map the 3C6/7/8/9 to the IGA2 */
        outb(0x1B,0x3C4);
        outb(sr1b | 0x80,0x3C5); /* Second Display Engine colck always on */
        outb(0x67,0x3D4);
        outb(cr67 & 0x3F,0x3D5); /* Second Display Color Depth 8 */
        outb(0x6A,0x3D4);
        outb(cr6a & 0xBF,0x3D5); /* Second Display Channel Reset CR6A[6]) */
        outb(cr6a | 0x80,0x3D5); /* Second Display Channel Enable CR6A[7] */
        outb(cr6a | 0xC0,0x3D5); /* Second Display Channel stop reset) */

        outb(0xFF,0x3c6); /* Bit mask of palette */
        outb(0x00,0x3C8);
        if(UNICHROME_CLE266 == chip_info.gfx_chip_name && rev >= 15)
        {
            shift = 8;
            write_reg_mask(CR6A, VIACR, BIT5, BIT5);
            write_reg_mask(SR15, VIASR, BIT7, BIT7);
        }
        for (i = 0; i < len; i++)
        {   
            outb((*(pred+i))>>shift,0x3C9);
            outb((*(pgreen+i))>>shift,0x3C9);
            outb((*(pblue+i))>>shift,0x3C9);
        }

        outb(0x1A,0x3C4);
        outb(sr1a & 0xFE,0x3C5); /* Map the 3C6/7/8/9 to the IGA1 */    

        outb(0xFF,0x3c6); /* Bit mask of palette */
        outb(0x00,0x3C8);
        for (i = 0; i < len; i++)
        {   
            outb((*(pred+i))>>shift,0x3C9);
            outb((*(pgreen+i))>>shift,0x3C9);
            outb((*(pblue+i))>>shift,0x3C9);
        } 

        outb(0x1A,0x3C4);
        outb(sr1a,0x3C5);
        outb(0x1B,0x3C4);
        outb(sr1b,0x3C5);
        outb(0x67,0x3D4);
        outb(cr67,0x3D5);
        outb(0x6A,0x3D4);
        outb(cr6a,0x3D5);
        break;
        case 16:
        if(len>17) return 0; /* Because static u32 pseudo_pal[17]; */
        for(i=0;i<len;i++) 
            ((u32 *)info->pseudo_palette)[i] = 
                (*(pred+i) & 0xF800)          | 
                ((*(pgreen+i) & 0xFC00) >> 5) | 
                ((*(pblue+i) & 0xF800) >> 11);
        break;
        case 32:
        if(len>17) return 0;
        if(ptransp) {
            for(i=0;i<len;i++)
                ((u32*)info->pseudo_palette)[i] =
                    ((*(ptransp+i) & 0xFF00) << 16)    |
                    ((*(pred+i) & 0xFF00) << 8)        |
                    ((*(pgreen+i) & 0xFF00))           |
                    ((*(pblue+i) & 0xFF00) >> 8);
        }
        else {
            for(i=0;i<len;i++)
                ((u32*)info->pseudo_palette)[i] =
                    0x00000000                         |
                    ((*(pred+i) & 0xFF00) << 8)        |
                    ((*(pgreen+i) & 0xFF00))           |
                    ((*(pblue+i) & 0xFF00) >> 8);
        }
        break;
    }
return 0;
}

static int viafb_pan_display(struct fb_var_screeninfo *var,
                 struct fb_info *info)
{
    unsigned int offset=0;
    
    DEBUG_MSG(KERN_INFO "viafb_pan_display!\n");

	if(var->xoffset > (var->xres_virtual - var->xres)) {
		return -EINVAL;
	}
	if(var->yoffset > (var->yres_virtual - var->yres)) {
		return -EINVAL;
	}

	if(var->vmode & FB_VMODE_YWRAP) return -EINVAL;

	if(var->xoffset + info->var.xres > info->var.xres_virtual ||
	   var->yoffset + info->var.yres > info->var.yres_virtual) {
		return -EINVAL;
	}
        /* begin add by zepeng for zerocopy mode ,switch on screen */
        offset = (var->xoffset + (var->yoffset * var->xres)) * var->bits_per_pixel/16;
   
        DEBUG_MSG(KERN_INFO "\nviafb_pan_display,offset =%d ",offset);

        write_reg_mask(0x48,0x3d4,((offset>>24) & 0x3),0x3);
        write_reg_mask(0x34,0x3d4,((offset>>16) & 0xff),0xff);
        write_reg_mask(0x0c,0x3d4,((offset>>8) & 0xff),0xff);
        write_reg_mask(0x0d,0x3d4,(offset & 0xff),0xff);

    ((struct viafb_par *)(info->par))->var.xoffset = var->xoffset;
    ((struct viafb_par *)(info->par))->var.yoffset = var->yoffset;

    return 0;
}

static int viafb_blank(int blank_mode, struct fb_info *info)
{
    DEBUG_MSG(KERN_INFO "viafb_blank!\n" );
    /* clear DPMS setting */

    switch (blank_mode) {
    case VESA_NO_BLANKING:
        /* Screen: On, HSync: On, VSync: On */
        write_reg_mask(CR36, VIACR, 0x00, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_HSYNC_SUSPEND:
        /* Screen: Off, HSync: Off, VSync: On */
        write_reg_mask(CR36, VIACR, 0x10, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_VSYNC_SUSPEND:
        /* Screen: Off, HSync: On, VSync: Off */
        write_reg_mask(CR36, VIACR, 0x20, BIT4+BIT5);   /* control CRT monitor power management */
        break;
    case VESA_POWERDOWN:
        /* Screen: Off, HSync: Off, VSync: Off */
        write_reg_mask(CR36, VIACR, 0x30, BIT4+BIT5);   /* control CRT monitor power management */
        break;
        }

    return 0;
}

/* Under FC5 and kernel after 2.6.16, the fb_ioctl's prototype is changed,*/
#if defined FC5_2_6_15 || (LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16))
static int viafb_ioctl(struct fb_info *info, u_int cmd, u_long arg)
#else
static int viafb_ioctl(struct inode *inode, struct file *file, u_int cmd,
               u_long arg, struct fb_info *info)
#endif
{
    struct viafb_ioctl_info viainfo;
    struct viafb_ioctl_mode viamode;
    struct viafb_ioctl_samm viasamm;
    struct viafb_driver_version driver_version;
    struct fb_var_screeninfo sec_var;
    /* Only for case "SET_DEVICE_INFO" and "GET_DEVICE_INFO" */
    struct viafb_ioctl_setting viafb_setting;  
    u32 state_info = 0;
    u32 item_info =0;
    u32 viafb_gamma_table[256];
    char driver_name[10]="viafb\0"; /* for driver name use */
    POSITIONVALUE view_size, view_pos;

    u32 __user  *argp = (u32 __user *)arg;
    u32         gpu32 = 0,ss;
    device_t active_dev;
    u32 video_dev_info = 0;
    ss = sizeof(active_dev);
    memset(&viafb_setting,0,sizeof(viafb_setting));
    memset(&active_dev,0,ss);

    DEBUG_MSG(KERN_INFO "viafb_ioctl: 0x%X !!\n", cmd);

    switch (cmd) 
    {
        case VIAFB_GET_CHIP_INFO: /* struct chip_information        chip_info ; */
            if(copy_to_user((void __user *)arg, &chip_info, sizeof(chip_info)))
                return -EFAULT;
            break;    
        case VIAFB_GET_INFO_SIZE:
            return put_user(sizeof(viainfo), argp);
        case VIAFB_GET_INFO:
            return ioctl_get_viafb_info(arg);
        case VIAFB_HOTPLUG:
            return put_user((u32)ioctl_hotplug(info->var.xres, info->var.yres, info->var.bits_per_pixel), argp);
            break;
        case VIAFB_SET_HOTPLUG_FLAG:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            HotPlug = (gpu32) ? 1 : 0;
            break;
        case VIAFB_GET_RESOLUTION:
            viamode.xres = (u32)HotPlug_Xres;
            viamode.yres = (u32)HotPlug_Yres;
            viamode.refresh = (u32)HotPlug_refresh;
            viamode.bpp = (u32)HotPlug_bpp;
            if(SAMM_ON==1){
                viamode.xres_sec=second_xres;
                viamode.yres_sec=second_yres;
                viamode.virtual_xres_sec = second_virtual_xres;
                viamode.virtual_yres_sec = second_virtual_yres;
                viamode.refresh_sec=refresh1;
                viamode.bpp_sec=bpp1;
            }else{
                viamode.xres_sec=0;
                viamode.yres_sec=0;
                viamode.virtual_xres_sec = 0;
                viamode.virtual_yres_sec = 0;
                viamode.refresh_sec=0;
                viamode.bpp_sec=0;
            }
            if(copy_to_user((void __user *)arg, &viamode, sizeof(viamode))) {
                return -EFAULT;
            }
            break;
        case VIAFB_GET_TV_TYPE:
            return ioctl_get_tv_type(arg);
        case VIAFB_GET_SAMM_INFO:
            viasamm.samm_status= SAMM_ON;
            
            if(SAMM_ON==1) {
                if(dual_fb) 
                {
                    viasamm.size_prim = parinfo.fbmem_free;
                    viasamm.size_sec = parinfo1.fbmem_free;
                }
                else 
                {
                    if(second_size)
                    {
                        viasamm.size_prim = parinfo.memsize - second_size*1024*1024;
                        if(accel)
                            viasamm.size_sec=second_size*1024*1024 - parinfo.fbmem_used;
                        else
                            viasamm.size_sec=second_size*1024*1024;
                    }
                    else
                    {
                        viasamm.size_prim=parinfo.memsize>>1;
                        if(accel)
                            viasamm.size_sec=(parinfo.memsize>>1) - parinfo.fbmem_used;
                        else
                            viasamm.size_sec=parinfo.memsize>>1;
                    }
                }
                viasamm.mem_base=parinfo.fbmem;
                viasamm.offset_sec=second_offset;
            }else{
                viasamm.size_prim=parinfo.memsize;
                viasamm.size_sec=0;
                viasamm.mem_base=parinfo.fbmem;
                viasamm.offset_sec=0;
            }
           
            if(copy_to_user((void __user *)arg, &viasamm, sizeof(viasamm))) 
                return -EFAULT;

            break;
        case VIAFB_TURN_ON_OUTPUT_DEVICE:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            if (gpu32 & CRT_Device)
                crt_enable();
            if (gpu32 & DVI_Device)
                dvi_enable();
            if (gpu32 & TV_Device)
                tv_enable();
            if (gpu32 & LCD_Device)
                lcd_enable();
            break;
        case VIAFB_TURN_OFF_OUTPUT_DEVICE:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            if (gpu32 & CRT_Device)
                crt_disable();
            if (gpu32 & DVI_Device)
                dvi_disable();
            if (gpu32 & TV_Device)
                tv_disable();
            if (gpu32 & LCD_Device)
                lcd_disable();
            break;
        case VIAFB_SET_DEVICE:
            if (copy_from_user(&active_dev, (void *)argp,ss))
            {
                return -EFAULT;
            }
            if(check_macrovision_enabled() && (active_dev.tv != TV_ON || TV_ON))
                break;
            viafb_set_device(active_dev);
            viafb_set_par(info);
            break;
        case VIAFB_GET_DEVICE:
            active_dev.crt = CRT_ON;
            active_dev.dvi = DVI_ON;
            active_dev.tv = TV_ON;
            active_dev.lcd = LCD_ON;
            active_dev.samm = SAMM_ON;
            active_dev.primary_dev = primary_dev;

            active_dev.tv_system = tv_system;
            active_dev.tv_level = tv_level;
            active_dev.tv_out_sig = tv_out_signal;
            active_dev.tv_dedotcrawl = tv_dedotcrawl;

            active_dev.lcd_dsp_cent = lcd_dsp_method; 
            active_dev.lcd_panel_id = lcd_panel_id;
            active_dev.lcd_mode = lcd_mode;

            active_dev.xres = HotPlug_Xres;
            active_dev.yres = HotPlug_Yres;

            active_dev.xres1 = second_xres;
            active_dev.yres1 = second_yres;
      
            active_dev.bpp = bpp;
            active_dev.bpp1 = bpp1;
            active_dev.refresh = refresh;
            active_dev.refresh1 = refresh1;
            
            active_dev.epia_dvi=EPIA_DVI;
            active_dev.lcd_dual_edge=LCDDualEdge;
            active_dev.bus_width=BusWidth;

            if(copy_to_user((void __user *)arg, &active_dev,ss)) 
                return -EFAULT;
            break;
        case VIAFB_SET_TV_FFILTER:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_ffilter(STATE_ON, gpu32);
            break;
        case VIAFB_SET_TV_COLOR_DEFAULT:
        {
            u32 def_val[4];
            tv_set_brightness(tv_setting_info.DefaultBrightness);
            tv_set_contrast(tv_setting_info.DefaultContrast);
            tv_set_saturation(tv_setting_info.DefaultSaturation);
            tv_set_tint(tv_setting_info.DefaultTINT);
            def_val[0] = tv_setting_info.DefaultBrightness;
            def_val[1] = tv_setting_info.DefaultContrast;
            def_val[2] = tv_setting_info.DefaultSaturation;
            def_val[3] = tv_setting_info.DefaultTINT;
            if(copy_to_user((void __user *)arg, &def_val, sizeof(u32)*4)) 
                return -EFAULT;
            break;
        }
        case VIAFB_SET_TV_BRIGHTNESS:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_brightness(gpu32);
            break;
        case VIAFB_SET_TV_CONTRAST:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_contrast(gpu32);
            break;
        case VIAFB_SET_TV_SATURATION:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_saturation(gpu32);
            break;
        case VIAFB_SET_TV_TINT:
            if(copy_from_user(&gpu32, argp, sizeof(gpu32))) {
                return -EFAULT;
            }
            tv_set_tint(gpu32);
            break;

        /* Add for getting driver version. */
        case VIAFB_GET_DRIVER_VERSION:
            driver_version.iMajorNum = VERSION_MAJOR;            
            driver_version.iKernelNum = VERSION_KERNEL;
            driver_version.iOSNum = VERSION_OS;
            driver_version.iMinorNum = VERSION_MINOR;
            
            if(copy_to_user((void __user *)arg, &driver_version, sizeof(driver_version)))
            {
                return -EFAULT;
            }
            
            break;

        /* Set and apply CRT,DVI,LCD,TV's setting info. */
        case VIAFB_SET_DEVICE_INFO:
            if(copy_from_user(&viafb_setting, (void *)argp,sizeof(viafb_setting)))
            {
                return -EFAULT;
            }
            if(check_macrovision_enabled() && (((viafb_setting.device_status & TV_Device)>> 2) != TV_ON || TV_ON))
                break;
            if(apply_device_setting(viafb_setting, info)<0)
            {
                return -EINVAL;
            }           
  
            break;

        case VIAFB_SET_SECOND_MODE:
             if(copy_from_user(&sec_var, (void *)argp,sizeof(sec_var)))
            {
                return -EFAULT;
            }
            apply_second_mode_setting(&sec_var);
            break;
        
        /*  Get current VIA framebuffer device setting info. */
        case VIAFB_GET_DEVICE_INFO:

            retrieve_device_setting(&viafb_setting);

            if(copy_to_user((void __user *)arg, &viafb_setting, sizeof(viafb_setting)))
            {
               return -EFAULT;
            }
			
            break;

        case VIAFB_GET_DEVICE_SUPPORT:
            get_device_support_state(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_DEVICE_CONNECT:
            get_device_connect_state(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_PANEL_SUPPORT_EXPAND:
            state_info = lcd_get_support_expand_state(info->var.xres, info->var.yres);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_SUPPORT_SIGNAL:
            tv_get_support_signal(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_SUPPORT_STANDARD:
            tv_get_support_standard(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_MAX_SIZE:
            state_info = tv_get_max_size();
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_MAX_POSITION:
            if (put_user(TV_HOR_POSITION_MAXIMUM, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_SUPPORT_TUNING_ITEM:
            tv_get_support_tuning_state(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
            
        case VIAFB_GET_TV_MAX_TUNING_VALUE:
            get_user(item_info, argp);
            tv_get_tuning_max_value(item_info, &state_info);
            put_user(state_info, argp);
            break;
            
        case VIAFB_GET_TV_SUPPORT_SETTING_ITEM:
            tv_get_support_setting_state(&state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;

        /* Add for setting TV position. */
        case VIAFB_SET_TV_POSITION:
            if(copy_from_user(&view_pos, (void *)argp, sizeof(POSITIONVALUE)))
            {
                return -EFAULT;
            }

            tv_set_position(view_pos.dwX, view_pos.dwY);
				 
            break;

        /* Add for setting TV size. */
        case VIAFB_SET_TV_SIZE:
            if(copy_from_user(&view_size, (void *)argp, sizeof(POSITIONVALUE)))
            {
                return -EFAULT;
            }

            tv_set_size(view_size.dwX, view_size.dwY);
		
            break;
            
        case VIAFB_GET_DRIVER_NAME:
            if(copy_to_user((void __user *)arg, driver_name, sizeof(driver_name)))
            {
                return -EFAULT;
            }
            break;
            
        case VIAFB_SET_GAMMA_LUT:
            if(copy_from_user(viafb_gamma_table, argp, sizeof(viafb_gamma_table)))
            {
                return -EFAULT;
            }
            set_gamma_table(bpp, viafb_gamma_table);            
            break;
            
        case VIAFB_GET_GAMMA_LUT:
            get_gamma_table(viafb_gamma_table);
            if(copy_to_user((void __user *)arg, viafb_gamma_table, sizeof(viafb_gamma_table)))
            {
                return -EFAULT;
            }
            break;
            
        case VIAFB_GET_GAMMA_SUPPORT_STATE:
            get_gamma_support_state(bpp, &state_info);
            if (put_user(state_info, argp))
            {
               return -EFAULT; 
            }
            break;
        case VIAFB_SET_VIDEO_DEVICE:
            get_user(video_dev_info, argp);
            viafb_set_video_device(video_dev_info);
            break;
        case VIAFB_GET_VIDEO_DEVICE:
            viafb_get_video_device(&video_dev_info);
            if (put_user(video_dev_info, argp))
            {
               return -EFAULT; 
            }
            break;
        default:
            return -EINVAL;
        }

    return 0;
}

static void viafb_fillrect(struct fb_info *info, const struct fb_fillrect *rect)
{
    u32 col = 0, rop = 0;
    int pitch;

    if(!accel)
        return cfb_fillrect(info, rect);

    if(!rect->width || !rect->height)
   	    return;

    switch (rect->rop)
    {
        case ROP_XOR:
            rop = 0x5A;
            break;
        case ROP_COPY:
        default:
            rop = 0xF0;
            break;
    }

    switch(info->var.bits_per_pixel)
    {
        case 8:
            col = rect->color;
            break;
        case 16:
            col = ((u32 *)(info->pseudo_palette))[rect->color];
            break;
        case 32:
            col = ((u32 *)(info->pseudo_palette))[rect->color];
            break;
    }

    /* BitBlt Source Address */
    MMIO_OUT32(VIA_REG_SRCPOS, 0x0);
    /* Source Base Address */
    MMIO_OUT32(VIA_REG_SRCBASE, 0x0);
    /* Destination Base Address */ 
    MMIO_OUT32(VIA_REG_DSTBASE, ((u32)(info->screen_base) - (u32)FB_MM) >> 3);
    /* Pitch */
    pitch = (info->var.xres_virtual +7) & ~7;
    MMIO_OUT32(VIA_REG_PITCH, VIA_PITCH_ENABLE | (((pitch * info->var.bits_per_pixel >> 3) >> 3) |
                (((pitch * info->var.bits_per_pixel >> 3) >> 3) << 16)));
    /* BitBlt Destination Address */
    MMIO_OUT32(VIA_REG_DSTPOS, ((rect->dy << 16) | rect->dx));
    /* Dimension: width & height */
    MMIO_OUT32(VIA_REG_DIMENSION, (((rect->height - 1) << 16) | (rect->width - 1)));
    /* Forground color or Destination color */
    MMIO_OUT32(VIA_REG_FGCOLOR, col);
    /* GE Command */
    MMIO_OUT32(VIA_REG_GECMD, (0x01|0x2000|(rop<<24)));

}

static void viafb_copyarea(struct fb_info *info, const struct fb_copyarea *area)
{
    u32 dy = area->dy, sy = area->sy, direction = 0x0;
    u32 sx = area->sx, dx = area->dx, width = area->width;	
    int pitch;

    DEBUG_MSG(KERN_INFO "viafb_copyarea!!\n");

    if(!accel)
        return cfb_copyarea(info, area);

    if (!area->width || !area->height)
        return;

    if (area->sy < area->dy)
    {
        dy += area->height - 1;
        sy += area->height - 1;
        direction |= 0x8000;
    }

    if (sx < dx)
    {
        dx += width - 1;
        sx += width - 1;
        direction |= 0x4000;
    }

    /* Source Base Address */
    MMIO_OUT32(VIA_REG_SRCBASE, ((u32)(info->screen_base) - (u32)FB_MM) >> 3);  
    /* Destination Base Address */
    MMIO_OUT32(VIA_REG_DSTBASE, ((u32)(info->screen_base) - (u32)FB_MM) >> 3);
    /* Pitch */
    pitch = (info->var.xres_virtual+7) & ~7;
    MMIO_OUT32(VIA_REG_PITCH, VIA_PITCH_ENABLE | (((pitch * info->var.bits_per_pixel >> 3) >> 3) |
                (((pitch * info->var.bits_per_pixel >> 3) >> 3) << 16)));
    /* BitBlt Source Address */
    MMIO_OUT32(VIA_REG_SRCPOS, ((area->sy << 16) | area->sx));
    /* BitBlt Destination Address */
    MMIO_OUT32(VIA_REG_DSTPOS, ((area->dy << 16) | area->dx));
    /* Dimension: width & height */
    MMIO_OUT32(VIA_REG_DIMENSION, (((area->height - 1) << 16) | (area->width - 1)));
    /* GE Command */
    MMIO_OUT32(VIA_REG_GECMD, (0x01|direction|(0xCC<<24)));

}

static void viafb_imageblit(struct fb_info *info, const struct fb_image *image)
{
    u32 size, bg_col = 0, fg_col = 0, *udata;
    int i;
    int pitch;

    if(!accel)
        return cfb_imageblit(info, image);

    udata = (u32*)image->data;

    switch(info->var.bits_per_pixel)
    {
        case 8:
            bg_col = image->bg_color;
            fg_col = image->fg_color;
            break;
        case 16:
            bg_col = ((u32 *)(info->pseudo_palette))[image->bg_color];
            fg_col = ((u32 *)(info->pseudo_palette))[image->fg_color];
            break;
        case 32:
            bg_col = ((u32 *)(info->pseudo_palette))[image->bg_color];
            fg_col = ((u32 *)(info->pseudo_palette))[image->fg_color];
            break;
    }
    size = image->width * image->height;

    /* Source Base Address */
    MMIO_OUT32(VIA_REG_SRCBASE, 0x0);
    /* Destination Base Address */
    MMIO_OUT32(VIA_REG_DSTBASE, ((u32)(info->screen_base) - (u32)FB_MM) >> 3);
    /* Pitch */
    pitch = (info->var.xres_virtual+7) & ~7;
    MMIO_OUT32(VIA_REG_PITCH, VIA_PITCH_ENABLE | (((pitch * info->var.bits_per_pixel >> 3) >> 3) |
                (((pitch * info->var.bits_per_pixel >> 3) >> 3) << 16)));
    /* BitBlt Source Address */
    MMIO_OUT32(VIA_REG_SRCPOS, 0x0);
    /* BitBlt Destination Address */
    MMIO_OUT32(VIA_REG_DSTPOS, ((image->dy << 16) | image->dx));
    /* Dimension: width & height */
    MMIO_OUT32(VIA_REG_DIMENSION, (((image->height - 1) << 16) | (image->width - 1)));
    /* fb color */
    MMIO_OUT32(VIA_REG_FGCOLOR, fg_col);
    /* bg color */
    MMIO_OUT32(VIA_REG_BGCOLOR, bg_col);
    /* GE Command */
    MMIO_OUT32(VIA_REG_GECMD, 0xCC020142);

    for(i=0;i<size/4;i++)
    {
        MMIO_OUT32(VIA_MMIO_BLTBASE, *udata);
        udata++;
    }

}

static int viafb_cursor(struct fb_info *info, struct fb_cursor *cursor)
{
    u8  data[CURSOR_SIZE/8];
    u32 data_bak[CURSOR_SIZE/32];
    u32 temp, xx, yy, bg_col = 0, fg_col = 0;
    int size, i, j = 0;
    /* Initial HW cursor flag */
    static int MAX_CURS = 32;

    if(!accel)
        return soft_cursor(info, cursor);

    /* For dual-fb, CLE266 only IGA1 use HW cursor. */
    if((((struct viafb_par *)(info->par))->iga_path==IGA2) && (chip_info.gfx_chip_name==UNICHROME_CLE266)) {
        return soft_cursor(info, cursor);
    }

    /* When duoview and using lcd , use soft cursor */
    if(LCD_ON || ((struct viafb_par *)(info->par))->duoview){
        return soft_cursor(info, cursor);
    }

    ShowHideHWCursor(info, HW_Cursor_OFF);
    #if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,10)
    viacursor = *cursor;
    #endif 

    if(cursor->set & FB_CUR_SETHOT)
    {
        viacursor.hot = cursor->hot;
        temp = ((viacursor.hot.x)<<16) + viacursor.hot.y;
        MMIO_OUT32(VIA_REG_CURSOR_ORG, temp);
    }

    if(cursor->set & FB_CUR_SETPOS)
    {
		viacursor.image.dx = cursor->image.dx;
		viacursor.image.dy = cursor->image.dy;
		yy = cursor->image.dy - info->var.yoffset;
		xx = cursor->image.dx - info->var.xoffset;
		temp = yy & 0xFFFF;
		temp |= (xx << 16);
        MMIO_OUT32(VIA_REG_CURSOR_POS, temp);
    }

    if(cursor->set & FB_CUR_SETSIZE)
    {
        temp = MMIO_IN32(VIA_REG_CURSOR_MODE);

        if((cursor->image.width <= 32)&&(cursor->image.height <= 32))
        {
            MAX_CURS = 32;
            temp |= 0x2;
        }
        else if((cursor->image.width <= 64)&&(cursor->image.height <= 64))
        {
            MAX_CURS = 64;
            temp &= 0xFFFFFFFD;
        }
        else
        {
            DEBUG_MSG(KERN_INFO "The cursor image is biger than 64x64 bits...\n");
            return -ENXIO;
        }
        MMIO_OUT32(VIA_REG_CURSOR_MODE, temp);

        viacursor.image.height = cursor->image.height;
        viacursor.image.width = cursor->image.width;
    }

    if(cursor->set & FB_CUR_SETCMAP)
    {
        viacursor.image.fg_color = cursor->image.fg_color;
        viacursor.image.bg_color = cursor->image.bg_color;

        switch(info->var.bits_per_pixel)
        {
            case 8:
                /* FIX ME:It seems that hardware cursor always work in true color mode */
                bg_col = (viafb_256_colors.red[viacursor.image.bg_color]>>8<<16);
                bg_col = bg_col |(viafb_256_colors.green[viacursor.image.bg_color]>>8<<8);
                bg_col = bg_col |(viafb_256_colors.blue[viacursor.image.bg_color]>>8);
                fg_col = (viafb_256_colors.red[viacursor.image.fg_color]>>8<<16);
                fg_col = fg_col |(viafb_256_colors.green[viacursor.image.fg_color]>>8<<8);
                fg_col = fg_col |(viafb_256_colors.blue[viacursor.image.fg_color]>>8);
                break;
            case 16:
                bg_col = ((u32 *)(info->pseudo_palette))[viacursor.image.bg_color];
                bg_col = (0xFF<<24)|((bg_col&0xF800)<<8)|((bg_col&0x7E0)<<5)|((bg_col&0x1F)<<3);
                fg_col = ((u32 *)(info->pseudo_palette))[viacursor.image.fg_color];
                fg_col = (0xFF<<24)|((fg_col&0xF800)<<8)|((fg_col&0x7E0)<<5)|((fg_col&0x1F)<<3);
                break;
            case 32:
                bg_col = ((u32 *)(info->pseudo_palette))[viacursor.image.bg_color];
                fg_col = ((u32 *)(info->pseudo_palette))[viacursor.image.fg_color];
                break;
        }

        MMIO_OUT32(VIA_REG_CURSOR_BG, bg_col);
        MMIO_OUT32(VIA_REG_CURSOR_FG, fg_col);
    }

    if(cursor->set & FB_CUR_SETSHAPE)
    {
        size = ((viacursor.image.width + 7) >> 3) * viacursor.image.height;

        if(MAX_CURS == 32)
        {
            for(i=0;i<(CURSOR_SIZE/32);i++)
            {
                data_bak[i] = 0x0;
                data_bak[i+1] = 0xFFFFFFFF;
                i += 1;
            }
        }
        else if(MAX_CURS == 64)
        {
            for(i=0;i<(CURSOR_SIZE/32);i++)
            {
                data_bak[i] = 0x0;
                data_bak[i+1] = 0x0;
                data_bak[i+2] = 0xFFFFFFFF;
                data_bak[i+3] = 0xFFFFFFFF;
                i += 3;
            }
        }

        switch (viacursor.rop)
        {
        /* The kernel always send ROP_XOR. */
        /* But for via's HW, we only need to copy the mask[i] to data[i], */
            case ROP_XOR:
                for (i = 0; i <size; i++)
                {
                    data[i] = viacursor.mask[i];
                }
                break;
            case ROP_COPY:
            
                for (i = 0; i < size; i++)
                {
                    data[i] = viacursor.mask[i]; 
                }
                break;
            default:
                break;
        }

        if(MAX_CURS == 32)
        {
            for(i=0;i<size;i++)
            {
                data_bak[j] = (u32)data[i];
                data_bak[j+1] = ~data_bak[j];
                j += 2;
            }
        }
        else if(MAX_CURS == 64)
        {
            for(i=0;i<size;i++)
            {
                data_bak[j] = (u32)data[i];
                data_bak[j+1] = 0x0;
                data_bak[j+2] = ~data_bak[j];
                data_bak[j+3] = ~data_bak[j+1];
                j += 4;
            }
        }

        memcpy(((struct viafb_par *)(info->par))->fbmem_virt+((struct viafb_par *)(info->par))->cursor_start, data_bak, CURSOR_SIZE);
    }

    if (viacursor.enable)
        ShowHideHWCursor(info, HW_Cursor_ON);

	return 0;
}

static int viafb_sync(struct fb_info *info)
{
    if(accel)
        WaitEngineIdle();

    return 0;
}

#endif

int get_mode_index(int hres, int vres,int flag)
{
    DEBUG_MSG(KERN_INFO "get_mode_index!\n" );

    if(flag==0){
    if (hres==640 && vres==480) {
        resMode = VIA_RES_640X480;
        mode = "640x480";
    } else if (hres==800 && vres==480) {
        resMode = VIA_RES_800X480;
        mode = "800x480";
    } else if (hres==800 && vres==600) {
        resMode = VIA_RES_800X600;
        mode = "800x600";
    } else if (hres==1024 && vres==768) {
        resMode = VIA_RES_1024X768;
        mode = "1024x768";
    } else if (hres==1152 && vres==864) {
        resMode = VIA_RES_1152X864;
        mode = "1152x864";
    } else if (hres==1280 && vres==1024) {
        resMode = VIA_RES_1280X1024;
        mode = "1280x1024";
    } else if (hres==1600 && vres==1200) {
        resMode = VIA_RES_1600X1200;
        mode = "1600x1200";
    } else if (hres==1440 && vres==1050) {
        resMode = VIA_RES_1440X1050;
        mode = "1440x1050";
    } else if (hres==1280 && vres==768) {
        resMode = VIA_RES_1280X768;
        mode = "1280x768";
    } else if (hres==1280 && vres==800) {
        resMode = VIA_RES_1280X800;
        mode = "1280x800";
	} else if (hres==1280 && vres==960) {
        resMode = VIA_RES_1280X960;
        mode = "1280x960";
    } else if (hres==1920 && vres==1440) {
        resMode = VIA_RES_1920X1440;
        mode = "1920x1440";
    } else if (hres==848 && vres==480) {
        resMode = VIA_RES_848X480;
        mode = "848x480";
    } else if (hres==1400 && vres==1050) {
        resMode = VIA_RES_1400X1050;
        mode = "1400x1050";
    } else if (hres==720 && vres==480) {
        resMode = VIA_RES_720X480;
        mode = "720x480";
    } else if (hres==720 && vres==576) {
        resMode = VIA_RES_720X576;
        mode = "720x576";
    } else if (hres==1024 && vres==512) {
        resMode = VIA_RES_1024X512;
        mode = "1024x512";
    } else if (hres==856 && vres==480) {
        resMode = VIA_RES_856X480;
        mode = "856x480";
    } else if (hres==1024 && vres==576) {
        resMode = VIA_RES_1024X576;
        mode = "1024x576";
    } else if (hres==1024 && vres==600){
    	resMode = VIA_RES_1024X600; 
        mode = "1024x600";
    } else if (hres==1280 && vres==720) {
        resMode = VIA_RES_1280X720;
        mode = "1280x720";
    } else if (hres==1920 && vres==1080) {
        resMode = VIA_RES_1920X1080;
        mode = "1920x1080";
    } else if (hres==1366 && vres==768){
    	 resMode = VIA_RES_1368X768; 
        mode = "1368x768";
    } else {
        resMode = VIA_RES_INVALID;
        mode = "640x480";
    }
    }else{
         if (hres==640 && vres==480) {
            resMode = VIA_RES_640X480;
            mode1 = "640x480";
        } else if (hres==800 && vres==480) {
            resMode = VIA_RES_800X480;
            mode1 = "800x480";
        } else if (hres==800 && vres==600) {
            resMode = VIA_RES_800X600;
            mode1 = "800x600";
        } else if (hres==1024 && vres==768) {
            resMode = VIA_RES_1024X768;
            mode1 = "1024x768";
        } else if (hres==1152 && vres==864) {
            resMode = VIA_RES_1152X864;
            mode1 = "1152x864";
        } else if (hres==1280 && vres==1024) {
            resMode = VIA_RES_1280X1024;
            mode1 = "1280x1024";
        }else if (hres==1600 && vres==1200) {
            resMode = VIA_RES_1600X1200;
            mode = "1600x1200";
        } else if (hres==1440 && vres==1050) {
            resMode = VIA_RES_1440X1050;
            mode1 = "1440x1050";
        } else if (hres==1280 && vres==768) {
            resMode = VIA_RES_1280X768;
            mode1 = "1280x768";
        } else if (hres==1280 && vres==800) {
            resMode = VIA_RES_1280X800;
            mode1 = "1280x800";
		} else if (hres==1280 && vres==960) {
            resMode = VIA_RES_1280X960;
            mode1 = "1280x960";
        } else if (hres==1920 && vres==1440) {
            resMode = VIA_RES_1920X1440;
            mode1 = "1920x1440";
        } else if (hres==848 && vres==480) {
            resMode = VIA_RES_848X480;
            mode1 = "848x480";
        } else if (hres==1400 && vres==1050) {
            resMode = VIA_RES_1400X1050;
            mode1 = "1400x1050";
        } else if (hres==720 && vres==480) {
            resMode = VIA_RES_720X480;
            mode1 = "720x480";
        } else if (hres==720 && vres==576) {
            resMode = VIA_RES_720X576;
            mode1 = "720x576";
        } else if (hres==1024 && vres==512) {
            resMode = VIA_RES_1024X512;
            mode1 = "1024x512";
        } else if (hres==856 && vres==480) {
            resMode = VIA_RES_856X480;
            mode1 = "856x480";
        } else if (hres==1024 && vres==576) {
            resMode = VIA_RES_1024X576;
            mode1 = "1024x576";            
        } else if (hres==1024 && vres==600){
    	    resMode = VIA_RES_1024X600; 
            mode1 = "1024x600";
        } else if (hres==1280 && vres==720) {
            resMode = VIA_RES_1280X720;
            mode1 = "1280x720";
         } else if (hres==1920 && vres==1080) {
            resMode = VIA_RES_1920X1080;
            mode1 = "1920x1080";
        } else if (hres==1366 && vres==768){
    	     resMode = VIA_RES_1368X768; 
            mode1 = "1368x768";
    	 }else {
            resMode = VIA_RES_INVALID;
            mode1 = "640x480";
        }
    }
    return(resMode);
}

bool is_available_tv_system(int system_id)
{
    switch (system_id)
    {
        case TVTYPE_NTSC:
        case TVTYPE_PAL:
        case TVTYPE_480P:
        case TVTYPE_576P:
        case TVTYPE_720P:
        case TVTYPE_1080I:
        {
            return TRUE;
        }

        default:
        {
            return FALSE;
        }
    }
}

bool is_available_tv_out_signal(int tv_out_signal)
{
    switch (tv_out_signal)
    {
        case TV_OUTPUT_COMPOSITE:
        case TV_OUTPUT_SVIDEO:
        case TV_OUTPUT_COMPOSITE_SVIDEO:
        case TV_OUTPUT_RGB:
        case TV_OUTPUT_YPBPR:
        case TV_OUTPUT_RGB_COMPOSITE:
        case TV_OUTPUT_YPBPR_COMPOSITE:
        case TV_OUTPUT_RGB_COMPOSITE_SVIDEO:
        case TV_OUTPUT_YPBPR_COMPOSITE_SVIDEO:
        {
            return TRUE;
        }

        default:
        {
            return FALSE;
        }
    }
}

int check_available_device_to_enable(int device_id)
{
    int device_num = 0;
    
    /* Initialize: */
    CRT_ON = STATE_OFF;
    DVI_ON = STATE_OFF;
    TV_ON = STATE_OFF;
    LCD_ON = STATE_OFF;
    LCD2_ON = STATE_OFF;
    DeviceStatus = None_Device;
    
    if ((device_id & CRT_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        CRT_ON = STATE_ON;
        device_num++;
        DeviceStatus |= CRT_Device;
    }
    
    if ((device_id & DVI_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        DVI_ON = STATE_ON;
        device_num++;
        DeviceStatus |= DVI_Device;
    }
    
    if ((device_id & TV_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        TV_ON = STATE_ON;
        device_num++;
        DeviceStatus |= TV_Device;
        /* tv_setting_info.system = tv_system = TVTYPE_NTSC; */
    }

    if ((device_id & HDTV_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        TV_ON = STATE_ON;
        device_num++;
        DeviceStatus |= TV_Device;
        /* tv_setting_info.system = tv_system = TVTYPE_480P; */
    }

    if ((device_id & LCD_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        LCD_ON = STATE_ON;
        device_num++;
        DeviceStatus |= LCD_Device;
    }

    if ((device_id & LCD2_Device) && (device_num < MAX_ACTIVE_DEV_NUM))
    {
        LCD2_ON = STATE_ON;
        device_num++;
        DeviceStatus |= LCD2_Device;
    }

    if (DeviceStatus == None_Device)
    {
        /* Use CRT as default active device: */
        CRT_ON = STATE_ON;
        DeviceStatus = CRT_Device;
    }

    DEBUG_MSG(KERN_INFO "Device Status:%x", DeviceStatus); 
    return device_num; 
}

void viafb_set_device(device_t active_dev)
{
    /* Check available device to enable: */
    int device_id = None_Device;
    int dev_num = 0;

    if (active_dev.crt)
    {
        device_id |= CRT_Device;
    }
    
    if (active_dev.dvi)
    {
        device_id |= DVI_Device;
    }
    
    if (active_dev.tv)
    {
        device_id |= TV_Device;
    }
    
    if (active_dev.lcd)
    {
        device_id |= LCD_Device;
    }

    dev_num = check_available_device_to_enable(device_id);
    
    /* Check property of TV: */
    if (TV_ON)
    {
        if (is_available_tv_system(active_dev.tv_system))
        {
            tv_setting_info.system = tv_system = active_dev.tv_system;
        }
        
        if (active_dev.tv_level <= TV_SIZE_LEVEL_MAXIMUM)
        {
            tv_setting_info.level = tv_level = active_dev.tv_level;
        }
        
        if (is_available_tv_out_signal(active_dev.tv_out_sig))
        {
            tv_setting_info.out_signal = tv_out_signal = active_dev.tv_out_sig;
        }
        
        if ((active_dev.tv_dedotcrawl == STATE_ON) || (active_dev.tv_dedotcrawl == STATE_OFF))
        {
            tv_setting_info.dedotcrawl = tv_dedotcrawl = active_dev.tv_dedotcrawl;
        }
    }

    /* Check property of LCD: */
    if (LCD_ON)
    {
        if (active_dev.lcd_dsp_cent)
        {
            lvds_setting_info.display_method = lcd_dsp_method = LCD_CENTERING;
        }
        else
        {
            lvds_setting_info.display_method = lcd_dsp_method = LCD_EXPANDSION; 
        }
        
        /* lcd_mode is for VT3324 LVDS. */
        if (active_dev.lcd_mode==LCD_SPWG)
        {
            lvds_setting_info.lcd_mode = lcd_mode= LCD_SPWG;
        }
        else
        {
            lvds_setting_info.lcd_mode = lcd_mode= LCD_OPENLDI; 
        }
        
        if(active_dev.lcd_panel_id <= LCD_PANEL_ID_MAXIMUM)
        {
            lcd_panel_id = active_dev.lcd_panel_id;
            init_lcd_size();
        }
    }

    /* Check property of mode: */
    if (!active_dev.xres1)
    {
        second_xres = 640;
    }
    else
    {
        second_xres = active_dev.xres1;
    }
    
    if (!active_dev.yres1)
    {
        second_yres = 480;
    }
    else
    {
        second_yres = active_dev.yres1;
    }

    if (active_dev.bpp != 0)
    {
        bpp = active_dev.bpp;
    }
    
    if (active_dev.bpp1 != 0)
    {
        bpp1 = active_dev.bpp1;
    }
    
    if (active_dev.refresh != 0)
    {
        refresh = active_dev.refresh;
    }
    
    if (active_dev.refresh1 != 0)
    {
        refresh1 = active_dev.refresh1;
    }
    
    if ((active_dev.samm == STATE_OFF) || (active_dev.samm == STATE_ON)) 
    {
        SAMM_ON = active_dev.samm;        
    }

    primary_dev = active_dev.primary_dev;
    
    set_start_addr();
    set_iga_path();
}

void viafb_set_video_device(u32 video_dev_info)
{
    VIDEO_ON_CRT = STATE_OFF;
    VIDEO_ON_DVI = STATE_OFF;
    VIDEO_ON_LCD = STATE_OFF;
    VIDEO_ON_TV  = STATE_OFF;

    /* Check available device to enable: */
    if((video_dev_info & CRT_Device) == CRT_Device)
    {
        VIDEO_ON_CRT = STATE_ON;
    }
    else if((video_dev_info & DVI_Device) == DVI_Device)
    {
        VIDEO_ON_DVI = STATE_ON;
    }
    else if((video_dev_info & LCD_Device) == LCD_Device)
    {
        VIDEO_ON_LCD = STATE_ON;
    }
    else if((video_dev_info & TV_Device) == TV_Device)
    {
        VIDEO_ON_TV = STATE_ON;
    }

}

void viafb_get_video_device(u32* video_dev_info)
{
    *video_dev_info = None_Device;
    if(VIDEO_ON_CRT == STATE_ON)
    {
        *video_dev_info |= CRT_Device;
    }
    else if(VIDEO_ON_DVI == STATE_ON)
    {
        *video_dev_info |= DVI_Device;
    }
    else if(VIDEO_ON_LCD == STATE_ON)
    {
        *video_dev_info |= LCD_Device;
    }
    else if(VIDEO_ON_TV == STATE_ON)
    {
        *video_dev_info |= TV_Device;
    }
}

/*    
 *       Purpose: to get the current primary display device type.
 *       Return: an integer which indicates the current primary device type.
 */
int get_primary_device()
{
    int primary_device = 0;
    /* Rule: device on iga1 path are the primary device. */
    if (SAMM_ON)
    {
        if (CRT_ON)
        {
            if (crt_setting_info.iga_path == IGA1)
            {
                DEBUG_MSG(KERN_INFO "CRT IGA Path:%d\n", crt_setting_info.iga_path);
                primary_device = CRT_Device;
            }
        }
        if (TV_ON)
        {
            if (tv_setting_info.iga_path == IGA1)
            {
                DEBUG_MSG(KERN_INFO "TV IGA Path:%d\n", tv_setting_info.iga_path);
                primary_device = TV_Device;
            }
        }
        if (DVI_ON)
        {
            if (tmds_setting_info.iga_path == IGA1)
            {
                DEBUG_MSG(KERN_INFO "DVI IGA Path:%d\n", tmds_setting_info.iga_path);
                primary_device = DVI_Device;
            }
        }
        if (LCD_ON)
        {
            if (lvds_setting_info.iga_path == IGA1)
            {
                DEBUG_MSG(KERN_INFO "LCD IGA Path:%d\n", lvds_setting_info.iga_path);
                primary_device = LCD_Device;
            }
        }
        if(LCD2_ON)
        {
            if (lvds_setting_info2.iga_path == IGA1)
            {
                DEBUG_MSG(KERN_INFO "LCD2 IGA Path:%d\n", lvds_setting_info2.iga_path);
                primary_device = LCD2_Device;
            }
        }
    }
    return primary_device;
}

u8 is_duoview(void)
{
    if(0 == SAMM_ON)
    {
        if(LCD_ON + TV_ON + LCD2_ON + DVI_ON + CRT_ON == 2)
        {
            return TRUE;
        }
        return FALSE;
    }
    else
    {
        return FALSE;
    }
}

void apply_second_mode_setting(struct fb_var_screeninfo*  sec_var)
{
    if((sec_var->xres_virtual * (sec_var->bits_per_pixel>> 3)) & 0x1F) /* Is 32 bytes alignment? */
    {
        sec_var->xres_virtual = (sec_var->xres_virtual + 31) & ~31; /* 32 pixel alignment */
    }
    second_xres = sec_var->xres;
    second_yres = sec_var->yres;
    second_virtual_xres = sec_var->xres_virtual;
    second_virtual_yres = sec_var->yres_virtual;
    bpp1 = sec_var->bits_per_pixel;
    refresh1 = get_refresh(sec_var->xres, sec_var->yres, sec_var->pixclock);
}

/* Apply setting info to device.(inclue device status, samm, tv/lcd attributes) */
int apply_device_setting(struct viafb_ioctl_setting setting_info, struct fb_info *info)
{
    int adaptive_ffilter_state = 0;
    int max_value = 0;
    int dev_num = 0;
    
    if (setting_info.device_flag)
    {
        dev_num = check_available_device_to_enable(setting_info.device_status);
    }

    /* Unlock TV's operation according to TV flag and check if the setting value is valid.
       If the value is valid, apply the new setting value to the device. */
    if(TV_ON)
    {            
        if(setting_info.tv_operation_flag & OP_TV_SYSTEM)
        {
            if(setting_info.tv_attributes.system <= TV_STANDARD_MAXIMUM)
            {
                tv_setting_info.system = tv_system = setting_info.tv_attributes.system;
            }
        }

        if((setting_info.tv_operation_flag & OP_TV_LEVEL) &&
            !(chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV))
        {
            if(setting_info.tv_attributes.level <= TV_SIZE_LEVEL_MAXIMUM)
            {
                if (chip_info.tv_chip_info.tv_chip_name == VT1625)
                {
                    tv_setting_info.level = tv_level = setting_info.tv_attributes.level;
                }
                else
                {
                    if (setting_info.tv_attributes.level == 0)
                    {
                        tv_setting_info.level = tv_level = 1;
                    }
                    else
                    {
                        tv_setting_info.level = tv_level = setting_info.tv_attributes.level;
                    }
                }
            }

            /* Restore to default view size (normal scan) */
            if (setting_info.tv_attributes.level == STATE_DEFAULT)
            {
                tv_setting_info.level = tv_level = TV_SIZE_NORMAL_SCAN;
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_OUT_SIGNAL)
        {       
            if(setting_info.tv_attributes.out_signal <= TV_OUT_SIGNAL_MAXIMUM)
            {
                tv_setting_info.out_signal = tv_out_signal = setting_info.tv_attributes.out_signal;					   
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_DEDOTCRAWL)
        {
            if(setting_info.tv_attributes.dedotcrawl== 1 || setting_info.tv_attributes.dedotcrawl == 0) 
            {
                tv_setting_info.dedotcrawl = tv_dedotcrawl = setting_info.tv_attributes.dedotcrawl;					   
            }
        }
    }

    /* Unlock LCD's operation according to LCD flag and check if the setting value is valid.
       If the value is valid, apply the new setting value to the device. */
    if(LCD_ON)
    {
        if (setting_info.lcd_operation_flag & OP_LCD_CENTERING)
        {
            DEBUG_MSG(KERN_INFO "set lcd expansion mode:%d\n", setting_info.lcd_attributes.display_center);
            if(setting_info.lcd_attributes.display_center)
            {
                lvds_setting_info.display_method = lcd_dsp_method = LCD_CENTERING;  /* Centering */
                lvds_setting_info2.display_method = lcd_dsp_method = LCD_CENTERING;
            }
            else
            {
                lvds_setting_info.display_method = lcd_dsp_method = LCD_EXPANDSION; /* expandsion */
                lvds_setting_info2.display_method = lcd_dsp_method = LCD_EXPANDSION; 
            }
        }
        
        /* lcd_mode is for VT3324 LVDS. */ 
        if (setting_info.lcd_operation_flag & OP_LCD_MODE)
        {
            if(setting_info.lcd_attributes.lcd_mode == LCD_SPWG)
            {
                lvds_setting_info.lcd_mode = lcd_mode = LCD_SPWG;
            }
            else
            {
                lvds_setting_info.lcd_mode = lcd_mode= LCD_OPENLDI;                
            }
            lvds_setting_info2.lcd_mode = lvds_setting_info.lcd_mode;
        }
        
        if (setting_info.lcd_operation_flag & OP_LCD_PANEL_ID)
        {
            if(setting_info.lcd_attributes.panel_id<= LCD_PANEL_ID_MAXIMUM)
            {
                lcd_panel_id = setting_info.lcd_attributes.panel_id;
                init_lcd_size();
            }
        }
    }
 
    if(0 != (setting_info.samm_status & OP_SAMM))
    {                
        setting_info.samm_status=setting_info.samm_status &(~OP_SAMM);
        if(setting_info.samm_status==0||setting_info.samm_status==1) 
        {
            SAMM_ON = setting_info.samm_status;
            
            if (SAMM_ON)
            {
                primary_dev = setting_info.primary_device;                
            }
            
            set_start_addr();
            set_iga_path();
        }
    }

    #if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
    parinfo.duoview = is_duoview();
    #endif

    /* If device status doesn't changed
       To set brightness, contrast, saturation, tint and position doesn't need to re-setmode. */
    if ((setting_info.device_flag == 0) && (
        (setting_info.tv_operation_flag & OP_TV_BRIGHTNESS) ||
        (setting_info.tv_operation_flag & OP_TV_CONTRAST) ||
        (setting_info.tv_operation_flag & OP_TV_SATURATION) ||
        (setting_info.tv_operation_flag & OP_TV_TINT) ||
        (setting_info.tv_operation_flag & OP_TV_POSITION) ||
        (setting_info.tv_operation_flag & OP_TV_SETTING_FFILTER) ||
        (setting_info.tv_operation_flag & OP_TV_TUNING_FFILTER) ||
        (setting_info.tv_operation_flag & OP_TV_SETTING_ADAPTIVE_FFILTER) ||
        (setting_info.tv_operation_flag & OP_TV_TUNING_ADAPTIVE_FFILTER) ||
        ((setting_info.tv_operation_flag & OP_TV_LEVEL) && (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV))))
    {
         /* Bypass */    
    }
    else
    {
        /* Apply setting information to device. */
        set_iga_path();

        #if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
        viafb_set_par(info);
        #endif
        #if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
        via_set_par(&viafbinfo.currentmode,info);
        #endif
    }
    
    /* Unlock TV's operation related to color according to TV's operation flag and check if 
       the setting value is valid. If the value is valid, apply the new setting value. */
    if (TV_ON)
    {
        if(setting_info.tv_operation_flag & OP_TV_SETTING_FFILTER)
        {
            DEBUG_MSG(KERN_INFO "set setting ffilter state:%d\n", setting_info.tv_attributes.ffilter_state);
            if(setting_info.tv_attributes.ffilter_state == STATE_ON)
            {                
                tv_set_ffilter(STATE_ON, 0);
            }
            else
            {
                tv_set_ffilter(STATE_OFF, 0);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_TUNING_FFILTER)
        {
            DEBUG_MSG(KERN_INFO "set tuning ffilter state:%d\n", setting_info.tv_attributes.ffilter);
            tv_get_tuning_max_value(OP_TV_TUNING_FFILTER, &max_value);
            
            if(setting_info.tv_attributes.ffilter <= max_value)
            {
                tv_ffilter = setting_info.tv_attributes.ffilter;
                tv_set_ffilter(STATE_ON, setting_info.tv_attributes.ffilter);
            }
            
            /* Restore to default value */
            if(setting_info.tv_attributes.ffilter == STATE_DEFAULT)
            {
                tv_set_ffilter(STATE_OFF, 0);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_SETTING_ADAPTIVE_FFILTER)
        {
            DEBUG_MSG(KERN_INFO "set setting Adaptive ffilter state:%d\n", setting_info.tv_attributes.adaptive_ffilter_state);
            /* Turn on adaptive ffilter */
            if (setting_info.tv_attributes.adaptive_ffilter_state == STATE_ON)
            {
                tv_set_adaptive_ffilter(STATE_ON, tv_get_ffilter(TV_FFILTER_TYPE_ADAPTIVE, &adaptive_ffilter_state));
            }
            /* Turn off adaptive ffilter or restore to default value */
            else
            {
                tv_set_adaptive_ffilter(STATE_OFF, 0);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_TUNING_ADAPTIVE_FFILTER)
        {
            DEBUG_MSG(KERN_INFO "set tuning ffilter state:%d\n", setting_info.tv_attributes.adaptive_ffilter);
            tv_get_tuning_max_value(OP_TV_TUNING_ADAPTIVE_FFILTER, &max_value);
            
            if(setting_info.tv_attributes.adaptive_ffilter <= max_value)
            {
                tv_set_adaptive_ffilter(STATE_ON, setting_info.tv_attributes.adaptive_ffilter);    
            }
            
            /* Restore to default value */
            if(setting_info.tv_attributes.adaptive_ffilter == STATE_DEFAULT)
            {
                tv_set_adaptive_ffilter(STATE_OFF, 0);    
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_BRIGHTNESS)
        {
            tv_get_tuning_max_value(OP_TV_BRIGHTNESS, &max_value);
            
            if(setting_info.tv_attributes.brightness <= max_value)
            {
                tv_brightness = setting_info.tv_attributes.brightness;
                tv_set_brightness(setting_info.tv_attributes.brightness);
            }
            
            /* Restore to default value */
            if (setting_info.tv_attributes.brightness == STATE_DEFAULT)
            {
                tv_brightness = tv_setting_info.DefaultBrightness;
                tv_set_brightness(tv_setting_info.DefaultBrightness);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_CONTRAST)
        {
            tv_get_tuning_max_value(OP_TV_CONTRAST, &max_value);
            
            if(setting_info.tv_attributes.contrast <= max_value)
            {
                tv_contrast = setting_info.tv_attributes.contrast;
                tv_set_contrast(setting_info.tv_attributes.contrast);
            }
            
            /* Restore to default value */
            if (setting_info.tv_attributes.contrast == STATE_DEFAULT)
            {
                tv_contrast = tv_setting_info.DefaultContrast;
                tv_set_contrast(tv_setting_info.DefaultContrast);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_SATURATION)
        {
            tv_get_tuning_max_value(OP_TV_SATURATION, &max_value);
            
            if(setting_info.tv_attributes.saturation <= max_value)
            {
                tv_saturation = setting_info.tv_attributes.saturation;
                tv_set_saturation(setting_info.tv_attributes.saturation);
            }
            
            /* Restore to default value */
            if (setting_info.tv_attributes.saturation == STATE_DEFAULT)
            {
                tv_saturation = setting_info.tv_attributes.saturation;
                tv_set_saturation(tv_setting_info.DefaultSaturation);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_TINT)
        {
            tv_get_tuning_max_value(OP_TV_TINT, &max_value);
            
            if(setting_info.tv_attributes.tint <= max_value)
            {
                tv_tint = setting_info.tv_attributes.tint;
                tv_set_tint(setting_info.tv_attributes.tint);
            }
            
            /* Restore to default value */
            if (setting_info.tv_attributes.tint == STATE_DEFAULT)
            {
                tv_tint = setting_info.tv_attributes.tint;
                tv_set_tint(tv_setting_info.DefaultTINT);
            }
        }

        if(setting_info.tv_operation_flag & OP_TV_POSITION)
        {
            u32 setting_hor_pos = setting_info.tv_attributes.horizontal_pos;
            u32 setting_ver_pos = setting_info.tv_attributes.vertical_pos;
            if(( setting_hor_pos <= TV_HOR_POSITION_MAXIMUM) && (setting_ver_pos <= TV_VER_POSITION_MAXIMUM))
            {
                tv_set_position(setting_hor_pos, setting_ver_pos);
            }
            
            /* Restore to default value */
            if (( setting_hor_pos == STATE_DEFAULT) && (setting_ver_pos == STATE_DEFAULT))
            {
                tv_set_position(TV_POS_DEFAULT_HOR_VALUE, TV_POS_DEFAULT_VER_VALUE);
            }
        }
        
        if ((setting_info.tv_operation_flag & OP_TV_LEVEL) && 
            (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV))
        {
            DEBUG_MSG("set integrated TV Hsize:%d Vsize:%d\n", setting_info.tv_attributes.CurrentScalH, setting_info.tv_attributes.CurrentScalV);
            set_integrated_tv_size(setting_info.tv_attributes.CurrentScalH, setting_info.tv_attributes.CurrentScalV);
        }
    }
    return dev_num;	
}


/* retrieve current device info */
/* include device status, samm, resolution, bpp, refresh, tv/lcd attributes */
void retrieve_device_setting(struct viafb_ioctl_setting *setting_info)
{
    int ffilter_state;
    int adaptive_ffilter_state;
    
    /* get device status */
    if(CRT_ON == 1)
    {
        setting_info->device_status = CRT_Device;
    }
    if(DVI_ON == 1)
    {
        setting_info->device_status |= DVI_Device;
    }
    if(LCD_ON == 1)
    {
        setting_info->device_status |= LCD_Device;
    }
    if(1 == LCD2_ON)
    {
        setting_info->device_status |= LCD2_Device;
    }
    if(TV_ON == 1)
    {
        if ((tv_setting_info.system == TVTYPE_NTSC) || (tv_setting_info.system == TVTYPE_PAL))
        {
            setting_info->device_status |= TV_Device;
        }
        else
        {
            setting_info->device_status |= HDTV_Device;
        }
    }

    if((VIDEO_ON_CRT == 1) && (CRT_ON == 1))
    {
        setting_info->video_device_status = crt_setting_info.iga_path;
    }
    else if((VIDEO_ON_DVI == 1) && (DVI_ON == 1))
    {
        setting_info->video_device_status = tmds_setting_info.iga_path;    
    }
    else if((VIDEO_ON_LCD == 1) && (LCD_ON == 1))
    {
        setting_info->video_device_status = lvds_setting_info.iga_path;    
    }
    else if((VIDEO_ON_TV == 1) && (TV_ON == 1))
    {
        setting_info->video_device_status = tv_setting_info.iga_path;
    }
    else
    {
        setting_info->video_device_status = 0;    
    }

    setting_info->samm_status= SAMM_ON;
    setting_info->primary_device = get_primary_device();
 
    setting_info->first_dev_bpp = bpp;
    setting_info->second_dev_bpp = bpp1;
 
    setting_info->first_dev_refresh = refresh;
    setting_info->second_dev_refresh = refresh1;
 
    setting_info->first_dev_hor_res = HotPlug_Xres;
    setting_info->first_dev_ver_res = HotPlug_Yres;
    setting_info->second_dev_hor_res = second_xres;
    setting_info->second_dev_ver_res = second_yres;

    /* Get TV information of tuning item. */
    setting_info->tv_attributes.brightness = tv_setting_info.CurrentBrightness;
    setting_info->tv_attributes.contrast = tv_setting_info.CurrentContrast;
    setting_info->tv_attributes.dedotcrawl = tv_setting_info.dedotcrawl;
    setting_info->tv_attributes.tint = tv_setting_info.CurrentTINT;    
    setting_info->tv_attributes.saturation = tv_setting_info.CurrentSaturation;
    
    if(chip_info.tv_chip_info.tv_chip_name==FS454)
    {
        setting_info->tv_attributes.CurrentScalH=tv_setting_info.CurrentScalH;
        setting_info->tv_attributes.CurrentScalV=tv_setting_info.CurrentScalV;
        setting_info->tv_attributes.ScalHLevel=tv_setting_info.ScalHLevel;
        setting_info->tv_attributes.ScalVLevel=tv_setting_info.ScalVLevel;
        setting_info->tv_attributes.DefaultScalH=tv_setting_info.DefaultScalH;	
        setting_info->tv_attributes.DefaultScalV=tv_setting_info.DefaultScalV;	

        setting_info->tv_attributes.PositionHLevel=tv_setting_info.PositionHLevel;
        setting_info->tv_attributes.PositionVLevel=tv_setting_info.PositionVLevel;
        setting_info->tv_attributes.DefaultPositionH=tv_setting_info.DefaultPositionH;
        setting_info->tv_attributes.DefaultPositionV=tv_setting_info.DefaultPositionV;
        setting_info->tv_attributes.horizontal_pos=tv_setting_info.CurrentPositionH;	
        setting_info->tv_attributes.vertical_pos=tv_setting_info.CurrentPositionV;					
    }
    else
    {
        /* Get current TV's screen position */
        if ((setting_info->tv_attributes.horizontal_pos == 0xFFFF) &&
            (setting_info->tv_attributes.vertical_pos == 0xFFFF))
        {
            setting_info->tv_attributes.horizontal_pos = tv_setting_info.DefaultPositionH;
            setting_info->tv_attributes.vertical_pos = tv_setting_info.DefaultPositionV;
        }
        else
        {
            setting_info->tv_attributes.horizontal_pos = tv_setting_info.CurrentPositionH;
            setting_info->tv_attributes.vertical_pos = tv_setting_info.CurrentPositionV;
        }
    }
    
    /* Get information of TV setting item */
    /* Get ffilter's value */
    setting_info->tv_attributes.ffilter 
        = tv_get_ffilter(TV_FFILTER_TYPE_NORMAL, &ffilter_state);    
    setting_info->tv_attributes.ffilter_state = ffilter_state;
    
    /* Get adaptive ffilter's value */
    setting_info->tv_attributes.adaptive_ffilter 
        = tv_get_ffilter(TV_FFILTER_TYPE_ADAPTIVE, &adaptive_ffilter_state);
    setting_info->tv_attributes.adaptive_ffilter_state = adaptive_ffilter_state;

    if (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV)
    {
        setting_info->tv_attributes.level = 0xFF; /* 0xFF means that we use x,y value instead of level valu. */
        setting_info->tv_attributes.CurrentScalH = tv_setting_info.CurrentScalH;
        setting_info->tv_attributes.CurrentScalV = tv_setting_info.CurrentScalV;
        DEBUG_MSG("get integrated TV current Hsize:%d Vsize:%d\n",tv_setting_info.CurrentScalH, tv_setting_info.CurrentScalV);
    }
    else
    {
        setting_info->tv_attributes.level = tv_setting_info.level;
        setting_info->tv_attributes.CurrentScalH = -1;
        setting_info->tv_attributes.CurrentScalV = -1;
    }
    
    setting_info->tv_attributes.out_signal = tv_setting_info.out_signal;
    setting_info->tv_attributes.system = tv_setting_info.system;
    setting_info->tv_attributes.dedotcrawl = tv_setting_info.dedotcrawl;

    /* Get lcd attributes */
    setting_info->lcd_attributes.display_center = lcd_dsp_method;
    setting_info->lcd_attributes.panel_id = lcd_panel_id;
    setting_info->lcd_attributes.lcd_mode = lcd_mode;
}

void parse_active_dev(void)
{
    CRT_ON = STATE_OFF;
    DVI_ON = STATE_OFF;
    LCD_ON = STATE_OFF;
    LCD2_ON = STATE_OFF;
    TV_ON = STATE_OFF;
        
    /* If use option "active_dev" to specify the devices to activate, we should:
       1. Modify the active status of devices.
       2. Keep the order of devices, so we can set corresponding IGA path to devices in SAMM case.
          Note: The previous of active_dev is primary device, and the following is secondary device. */
    if (!strncmp(active_dev, "CRT+DVI", 7))  /* CRT+DVI */
    {
        CRT_ON = STATE_ON;
        DVI_ON = STATE_ON;
        primary_dev = CRT_Device;        
    }
    else if (!strncmp(active_dev, "DVI+CRT", 7))  /* DVI+CRT */
    {
        CRT_ON = STATE_ON;
        DVI_ON = STATE_ON;
        primary_dev = DVI_Device;
    }
    else if (!strncmp(active_dev, "CRT+TV", 6))   /* CRT+TV */
    {
        CRT_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = CRT_Device;
    }
    else if (!strncmp(active_dev, "TV+CRT", 6))   /* TV+CRT */
    {
        CRT_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = TV_Device;
    }
    else if (!strncmp(active_dev, "CRT+LCD", 7))  /* CRT+LCD */
    {
        CRT_ON = STATE_ON;
        LCD_ON = STATE_ON;
        primary_dev = CRT_Device;
    }
    else if (!strncmp(active_dev, "LCD+CRT", 7))  /* LCD+CRT */
    {
        CRT_ON = STATE_ON;
        LCD_ON = STATE_ON;
        primary_dev = LCD_Device;
    }
    else if (!strncmp(active_dev, "DVI+LCD", 7))  /* DVI+LCD */
    {
        DVI_ON = STATE_ON;
        LCD_ON = STATE_ON;
        primary_dev = DVI_Device;
    }
    else if (!strncmp(active_dev, "LCD+DVI", 7))  /* LCD+DVI */
    {
        DVI_ON = STATE_ON;
        LCD_ON = STATE_ON;
        primary_dev = LCD_Device;
    }
    else if (!strncmp(active_dev, "DVI+TV", 6))   /* DVI+TV */
    {
        DVI_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = DVI_Device;
    }
    else if (!strncmp(active_dev, "TV+DVI", 6))   /* TV+DVI */
    {
        DVI_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = TV_Device;
    }
    else if (!strncmp(active_dev, "LCD+TV", 6))   /* LCD+TV */
    {
        LCD_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = LCD_Device;
    }
    else if (!strncmp(active_dev, "TV+LCD", 6))   /* TV+LCD */
    {
        LCD_ON = STATE_ON;
        TV_ON = STATE_ON;
        primary_dev = TV_Device;
    }else if(!strncmp(active_dev,"LCD+LCD2", 8))  /* LCD+LCD2 */
    {
        LCD_ON = STATE_ON;
        LCD2_ON = STATE_ON;
        primary_dev = LCD_Device;
    }else if(!strncmp(active_dev,"LCD2+LCD", 8))  /* LCD2+LCD */
    {
        LCD_ON = STATE_ON;
        LCD2_ON = STATE_ON;
        primary_dev = LCD2_Device;
    }
    else if (!strncmp(active_dev, "CRT", 3))   /* CRT only */
    {
        CRT_ON = STATE_ON;
        SAMM_ON = STATE_OFF;
    }
    else if (!strncmp(active_dev, "DVI", 3))   /* DVI only */
    {
        DVI_ON = STATE_ON;
        SAMM_ON = STATE_OFF;
    }
    else if (!strncmp(active_dev, "LCD", 3))   /* LCD only */
    {
        LCD_ON = STATE_ON;
        SAMM_ON = STATE_OFF;
    }
    else if (!strncmp(active_dev, "TV", 2))   /* TV only */
    {
        TV_ON = STATE_ON;
        SAMM_ON = STATE_OFF;
    }
    else
    {
        CRT_ON = STATE_ON;
        SAMM_ON = STATE_OFF;
    }

    #if LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0)
    parinfo.duoview = is_duoview();
    #endif
}

void parse_video_dev(void)
{
    VIDEO_ON_CRT = STATE_OFF;
    VIDEO_ON_DVI = STATE_OFF;
    VIDEO_ON_LCD = STATE_OFF;
    VIDEO_ON_TV  = STATE_OFF;
        
    if (!strncmp(video_dev, "CRT", 3))   /* Video on CRT */
    {
        VIDEO_ON_CRT = STATE_ON;
    }
    else if (!strncmp(video_dev, "DVI", 3))   /* Video on DVI */
    {
        VIDEO_ON_DVI = STATE_ON;
    }
    else if (!strncmp(video_dev, "LCD", 3))   /* Video on LCD */ 
    {
        VIDEO_ON_LCD = STATE_ON;
    }
    else if (!strncmp(video_dev, "TV", 2))   /* Video on TV */
    {
        VIDEO_ON_TV = STATE_ON;
    }
}

void parse_lcd_port(void)
{
    if (!strncmp(lcd_port, "DVP0", 4))
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_DVP0;
    }
    else if (!strncmp(lcd_port, "DVP1", 4))
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_DVP1;
    }
    else if  (!strncmp(lcd_port, "DFP_HIGHLOW", 11))
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_DFP;
    }
    else if  (!strncmp(lcd_port, "DFP_HIGH", 8))
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_DFP_HIGH;
    }
    else if  (!strncmp(lcd_port, "DFP_LOW", 8))
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_DFP_LOW;
    }
    else
    {
        chip_info.lvds_chip_info.output_interface = INTERFACE_NONE;
    }
    /* Initialize to avoid unexpected behavior */
    chip_info.lvds_chip_info2.output_interface = INTERFACE_NONE;
    
    DEBUG_MSG(KERN_INFO "parse_lcd_port: lcd_port:%s,interface:%d\n",lcd_port,chip_info.lvds_chip_info.output_interface);
}

/* Parse tv port option. */
void parse_tv_port(void)
{
    if (!strncmp(tv_port, "DVP0", 4))
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_DVP0;
    }
    else if (!strncmp(tv_port, "DVP1", 4))
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_DVP1;
    }
    else if  (!strncmp(tv_port, "DFP_HIGHLOW", 11))
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_DFP;
    }
    else if  (!strncmp(tv_port, "DFP_HIGH", 8))
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_DFP_HIGH;
    }
    else if  (!strncmp(tv_port, "DFP_LOW", 8))
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_DFP_LOW;
    }
    else
    {
        chip_info.tv_chip_info.output_interface = INTERFACE_NONE;
    }    
    
    DEBUG_MSG(KERN_INFO "parse_tv_port: tv_port:%s,interface:%d\n",tv_port,chip_info.tv_chip_info.output_interface);
}
void parse_dvi_port(void)
{
    if (!strncmp(dvi_port, "DVP0", 4))
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_DVP0;
    }
    else if (!strncmp(dvi_port, "DVP1", 4))
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_DVP1;
    }
    else if  (!strncmp(dvi_port, "DFP_HIGHLOW", 11))
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_DFP;
    }
    else if  (!strncmp(dvi_port, "DFP_HIGH", 8))
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_DFP_HIGH;
    }
    else if  (!strncmp(dvi_port, "DFP_LOW", 8))
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_DFP_LOW;
    }
    else
    {
        chip_info.tmds_chip_info.output_interface = INTERFACE_NONE;
    }    
    
    DEBUG_MSG(KERN_INFO "parse_dvi_port: dvi_port:%s,interface:%d\n",dvi_port,chip_info.tmds_chip_info.output_interface);
}


#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,0)
/*
 * The proc filesystem read function, a simple proc implement to get the value of DPA setting
 * DVP0,   DVP0DataDriving,  DVP0ClockDriving, DVP1, DVP1Driving, DFPHigh, DFPLow 
 * CR96,   SR2A[5], SR1B[1], SR2A[4], SR1E[2], CR9B,    SR65,    CR97,    CR99
 */
static int viafb_dvp0_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 dvp0_data_dri = 0, dvp0_clk_dri = 0, dvp0 = 0;
    dvp0_data_dri = (read_reg(VIASR ,SR2A) & BIT5) >> 4 |(read_reg(VIASR ,SR1B) & BIT1) >> 1;
    dvp0_clk_dri = (read_reg(VIASR ,SR2A) & BIT4) >> 3 |(read_reg(VIASR ,SR1E) & BIT2) >> 2;
    dvp0 = read_reg(VIACR, CR96)&0x0f;    
    len += sprintf(buf+len, "%x %x %x\n", dvp0, dvp0_data_dri, dvp0_clk_dri);
    *eof = 1; /* Inform kernel end of data */
    return len;
}
static int viafb_dvp0_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[20], *value, *pbuf;
    u8 reg_val = 0 ;
    unsigned long length, i;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 20 ? 20 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    pbuf = &buf[0];
    for(i = 0; i < 3; i++)
    {
        if((value = strsep(&pbuf, " ")) != NULL)
        {
            reg_val = simple_strtoul(value, NULL, 0);
            DEBUG_MSG(KERN_INFO "DVP0:reg_val[%d]=:%x\n", i, reg_val);
            switch(i)
            {
                case 0:
                    write_reg_mask(CR96, VIACR, reg_val, 0x0f);
                    break;
                case 1:
                    write_reg_mask(SR2A, VIASR, reg_val<<4, BIT5);
                    write_reg_mask(SR1B, VIASR, reg_val<<1, BIT1);
                    break;
                case 2:
                    write_reg_mask(SR2A, VIASR, reg_val<<3, BIT4);
                    write_reg_mask(SR1E, VIASR, reg_val<<2, BIT2);
                    break;
                default:
                    break;
            }
        }
        else
        {
            break;
        }
    }
    return count;
}
static int viafb_dvp1_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 dvp1 = 0, dvp1_data_dri = 0, dvp1_clk_dri = 0;
    dvp1 = read_reg(VIACR, CR9B)&0x0f;
    dvp1_data_dri = (read_reg(VIASR, SR65)&0x0c) >> 2;
    dvp1_clk_dri = read_reg(VIASR, SR65)&0x03;
    len += sprintf(buf+len, "%x %x %x\n", dvp1, dvp1_data_dri, dvp1_clk_dri);
    *eof = 1; /* Inform kernel end of data */
    return len;
}
static int viafb_dvp1_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[20], *value, *pbuf;
    u8 reg_val = 0 ;
    unsigned long length, i;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 20 ? 20 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    pbuf = &buf[0];
    for(i = 0; i < 3; i++)
    {
        if((value = strsep(&pbuf, " ")) != NULL)
        {
            reg_val = simple_strtoul(value, NULL, 0);
            switch(i)
            {
                case 0:
                    write_reg_mask(CR9B, VIACR, reg_val, 0x0f);
                    break;
                case 1:
                    write_reg_mask(SR65, VIASR, reg_val<<2, 0x0c);                    
                    break;
                case 2:
                    write_reg_mask(SR65, VIASR, reg_val, 0x03);
                    break;
                default:
                    break;
            }
        }
        else
        {
            break;
        }
    }
    return count;
}

static int viafb_dfph_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 dfp_high = 0;
    dfp_high = read_reg(VIACR, CR97)&0x0f;
    len += sprintf(buf+len, "%x\n", dfp_high);
    *eof = 1; /* Inform kernel end of data */
    return len;
}
static int viafb_dfph_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[20];
    u8 reg_val = 0 ;
    unsigned long length;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 20 ? 20 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    reg_val = simple_strtoul(&buf[0], NULL, 0);
    write_reg_mask(CR97, VIACR, reg_val, 0x0f);
    return count;
}
static int viafb_dfpl_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 dfp_low = 0;
    dfp_low = read_reg(VIACR, CR99)&0x0f;
    len += sprintf(buf+len, "%x\n", dfp_low);
    *eof = 1; /* Inform kernel end of data */
    return len;
}
static int viafb_dfpl_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[20];
    u8 reg_val = 0 ;
    unsigned long length;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 20 ? 20 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    reg_val = simple_strtoul(&buf[0], NULL, 0);
    write_reg_mask(CR99, VIACR, reg_val, 0x0f);
    return count;
}
static int viafb_vt1636_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 vt1636_08 = 0, vt1636_09 = 0;
    switch(chip_info.lvds_chip_info.lvds_chip_name)
    {
        case VT1636_LVDS:
            vt1636_08 = gpio_i2c_read_lvds(&lvds_setting_info, &chip_info.lvds_chip_info, 0x08) & 0x0f;
            vt1636_09 = gpio_i2c_read_lvds(&lvds_setting_info, &chip_info.lvds_chip_info, 0x09) & 0x1f;
            len += sprintf(buf+len, "%x %x\n", vt1636_08, vt1636_09);
            break;
        default:
            break;                    
    }
    switch(chip_info.lvds_chip_info2.lvds_chip_name)
    {
        case VT1636_LVDS:
            vt1636_08 = gpio_i2c_read_lvds(&lvds_setting_info2, &chip_info.lvds_chip_info2, 0x08) & 0x0f;
            vt1636_09 = gpio_i2c_read_lvds(&lvds_setting_info2, &chip_info.lvds_chip_info2, 0x09) & 0x1f;
            len += sprintf(buf+len, " %x %x\n", vt1636_08, vt1636_09);
            break;
        default:
            break;                    
    }
    *eof = 1; /* Inform kernel end of data */
    return len;
}
static int viafb_vt1636_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[30], *value, *pbuf;
    IODATA reg_val;
    unsigned long length, i;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 30 ? 30 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    pbuf = &buf[0];
    switch(chip_info.lvds_chip_info.lvds_chip_name)
    {
        case VT1636_LVDS:
            for(i = 0; i < 2; i++)
            {
                if((value = strsep(&pbuf, " ")) != NULL)
                {
                    reg_val.Data= simple_strtoul(value, NULL, 0);
                    switch(i)
                    {
                        case 0:
                            reg_val.Index = 0x08;
                            reg_val.Mask = 0x0f;
                            gpio_i2c_write_mask_lvds(&lvds_setting_info, &chip_info.lvds_chip_info, reg_val);
                            break;
                        case 1:
                            reg_val.Index = 0x09;
                            reg_val.Mask = 0x1f;
                            gpio_i2c_write_mask_lvds(&lvds_setting_info, &chip_info.lvds_chip_info, reg_val);                  
                            break;
                        default:
                            break;
                    }
                }
                else
                {
                    break;
                }
            }
            break;
        default:
            break;                    
    }
    switch(chip_info.lvds_chip_info2.lvds_chip_name)
    {
        case VT1636_LVDS:
            for(i = 0; i < 2; i++)
            {
                if((value = strsep(&pbuf, " ")) != NULL)
                {
                    reg_val.Data = simple_strtoul(value, NULL, 0);
                    switch(i)
                    {
                        case 0:
                            reg_val.Index = 0x08;
                            reg_val.Mask = 0x0f;
                            gpio_i2c_write_mask_lvds(&lvds_setting_info2, &chip_info.lvds_chip_info2, reg_val);
                            break;
                        case 1:
                            reg_val.Index = 0x09;
                            reg_val.Mask = 0x1f;
                            gpio_i2c_write_mask_lvds(&lvds_setting_info2, &chip_info.lvds_chip_info2, reg_val);                  
                            break;
                        default:
                            break;
                    }
                }
                else
                {
                    break;
                }
            }
            break;
        default:
            break;                    
    }
    return count;
}
static int viafb_vt1625_proc_read(char *buf, char **start, off_t offset, int count, int *eof, void *data)
{
    int len = 0;
    u8 vt1625_05 = 0;
    switch(chip_info.tv_chip_info.tv_chip_name)
    {
        case VT1625:
            vt1625_05 = tv_register_read(0x05) & 0x0f;
            len += sprintf(buf+len, "%x\n", vt1625_05);
            break;
        default:
            break;
    }
    *eof = 1; /* Inform kernel end of data */
    return len;
}


static int viafb_vt1625_proc_write(struct file *file, const char __user *buffer, unsigned long count, 
                                                void *data)
{
    char buf[20];
    unsigned long length;
    u8 reg_val = 0 ;
    if (count < 1) 
    {
        return -EINVAL;
    }
    length = count > 20 ? 20 : count;
    if (copy_from_user(&buf[0], buffer, length)) 
		return -EFAULT;
    buf[length-1] = '\0'; /* Ensure end string */
    switch(chip_info.tv_chip_info.tv_chip_name)
    {
        case VT1625:
            reg_val = simple_strtoul(&buf[0], NULL, 0);
            reg_val &= 0x0f;
            reg_val |= tv_register_read(0x05) & (~0x0f);
            tv_register_write(0x05, reg_val);
            break;
        default:
            break;
    }
    return count;
}

static void viafb_init_proc(struct proc_dir_entry *viafb_entry)
{
    struct proc_dir_entry *entry;
    viafb_entry = proc_mkdir("viafb", NULL);
    if(viafb_entry)
    {
        entry = create_proc_entry("dvp0", 0, viafb_entry);
        if(entry)
        {
            entry->owner = THIS_MODULE;
            entry->read_proc = viafb_dvp0_proc_read;
            entry->write_proc = viafb_dvp0_proc_write;
        }
        entry = create_proc_entry("dvp1", 0, viafb_entry);
        if(entry)
        {
            entry->owner = THIS_MODULE;
            entry->read_proc = viafb_dvp1_proc_read;
            entry->write_proc = viafb_dvp1_proc_write;
        }
        entry = create_proc_entry("dfph", 0, viafb_entry);
        if(entry)
        {
            entry->owner = THIS_MODULE;
            entry->read_proc = viafb_dfph_proc_read;
            entry->write_proc = viafb_dfph_proc_write;
        }
        entry = create_proc_entry("dfpl", 0, viafb_entry);
        if(entry)
        {
            entry->owner = THIS_MODULE;
            entry->read_proc = viafb_dfpl_proc_read;
            entry->write_proc = viafb_dfpl_proc_write;
        }
        if(VT1636_LVDS == chip_info.lvds_chip_info.lvds_chip_name || 
            VT1636_LVDS == chip_info.lvds_chip_info2.lvds_chip_name)
        {
            entry = create_proc_entry("vt1636", 0, viafb_entry);
            if(entry)
            {
                entry->owner = THIS_MODULE;
                entry->read_proc = viafb_vt1636_proc_read;
                entry->write_proc = viafb_vt1636_proc_write;
            }                      
        }
        if(VT1625 == chip_info.tv_chip_info.tv_chip_name)
        {
            entry = create_proc_entry("vt1625", 0, viafb_entry);
            if(entry)
            {
                entry->owner = THIS_MODULE;
                entry->read_proc = viafb_vt1625_proc_read;
                entry->write_proc = viafb_vt1625_proc_write;
            }                      
        }
    }
}
static void viafb_remove_proc(struct proc_dir_entry *viafb_entry)
{
    /* no problem if it was not registered */
    remove_proc_entry("dvp0", viafb_entry); /* parent dir */
    remove_proc_entry("dvp1", viafb_entry);
    remove_proc_entry("dfph", viafb_entry);
    remove_proc_entry("dfpl", viafb_entry);
    remove_proc_entry("vt1636", viafb_entry);
    remove_proc_entry("vt1625", viafb_entry);
}
#endif

static int __devinit via_pci_probe(void)
{

    /* unsigned char revision; */
    unsigned int default_xres,default_yres;
    char *tmpc,*tmpm;
    char *tmpc_sec,*tmpm_sec;
    int vmode_index;

    DEBUG_MSG(KERN_INFO "VIAFB PCI Probe!!\n");
    /* convert serial number to bitwise value. */
    tv_system = input_parameter_converter(tv_system);
    tv_out_signal = input_parameter_converter(tv_out_signal);
    
    /* For dual-fb, apart the fb memory just like SAMM. */
    if(dual_fb) SAMM_ON=1;
    parse_active_dev();
    parse_video_dev();
    parse_lcd_port();   
    parse_tv_port();
    parse_dvi_port();
    
    /* for dual-fb must SAMM_ON=1 and dual_fb=1 */
    if(!SAMM_ON) dual_fb=0; 

    init_chip_info();

    /* if need to accelerate PCI performance, you can use back door of video starting address. */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    /* Get fb info from pci first, instead of SR30 */
    get_fb_info(&viafbinfo.fbmem, &viafbinfo.memsize);
    viafbinfo.fbmem_virt = (unsigned int)ioremap_nocache(viafbinfo.fbmem, viafbinfo.memsize);

    viafbinfo.gen.info.screen_base =  (char *)viafbinfo.fbmem_virt;

    if (!viafbinfo.fbmem_virt) {
        printk("ioremap failed\n");
        return -1;
    }

    get_mmio_info(&viafbinfo.mmio_base, &viafbinfo.mmio_len);
    viafbinfo.io_virt = (unsigned int)ioremap_nocache(viafbinfo.mmio_base, viafbinfo.mmio_len);

    /* Add for VT3324 Integrated TV. */
    if (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV)
    {
        if (init_integrated_tv_regs() == FAIL)
        {
            printk("ioremap for integrated_tv_map_base failed\n");
            return -1;
        }
    }

    viafbinfo.gen.parsize = sizeof (struct viafb_par);
    viafbinfo.gen.fbhw = &via_hwswitch;
    strcpy(viafbinfo.gen.info.modename, viafb_name);
    viafbinfo.gen.info.changevar = NULL;
    viafbinfo.gen.info.disp = &disp;
    viafbinfo.gen.info.switch_con = &fbgen_switch;
    viafbinfo.gen.info.updatevar = &fbgen_update_var;
    viafbinfo.gen.info.blank = &fbgen_blank;
    viafbinfo.gen.info.fontname[0] = '\0';
    viafbinfo.gen.info.node = NODEV;
    viafbinfo.gen.info.fbops = &viafb_ops;
    viafbinfo.gen.info.flags = FBINFO_FLAG_DEFAULT;
    viafbinfo.gen.info.pseudo_palette = pseudo_pal;

  
    if(second_size && (second_size >= viafbinfo.memsize - (16*1024*1024)))
        second_size = (viafbinfo.memsize>>20) - 16;

    if(second_size && (second_size*1024*1024 <= (16*1024*1024)))
        second_size = 16;

    if(second_size)
        second_offset = viafbinfo.memsize - second_size*1024*1024;	
    else
        second_offset = viafbinfo.memsize >> 1;
	 
    FB_MM=viafbinfo.fbmem_virt; 

    viafbinfo.currentmode.accel = 0;
#else
    /* Get fb info from pci first, instead of SR30 */
    get_fb_info(&parinfo.fbmem, &parinfo.memsize);
    parinfo.fbmem_free = parinfo.memsize;
    parinfo.fbmem_used = 0;

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
    parinfo.fbmem_virt = ioremap_nocache(parinfo.fbmem, parinfo.memsize);
    viafbinfo.screen_base = (char *)parinfo.fbmem_virt;
#else
    parinfo.fbmem_virt = (unsigned int)ioremap_nocache(parinfo.fbmem, parinfo.memsize);
    viafbinfo.screen_base = (char *)parinfo.fbmem_virt;
#endif

    if (!parinfo.fbmem_virt) {
        printk("ioremap failed\n");
        return -1;
    }

    get_mmio_info(&parinfo.mmio_base, &parinfo.mmio_len);

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
    parinfo.io_virt = ioremap_nocache(parinfo.mmio_base, parinfo.mmio_len);
#else
    parinfo.io_virt = (unsigned int)ioremap_nocache(parinfo.mmio_base, parinfo.mmio_len);
#endif

    /* Add for VT3324 Integrated TV. */
    if (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV)
    {
        if (init_integrated_tv_regs() == FAIL)
        {
            printk("ioremap for integrated_tv_map_base failed\n");
            return -1;
        }
    }
    
    viafbinfo.par = &parinfo;
    viafbinfo.node = 0;
    viafbinfo.fbops = &viafb_ops;

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
    viafbinfo.flags = FBINFO_DEFAULT|FBINFO_HWACCEL_YPAN;
#else
    viafbinfo.flags = FBINFO_FLAG_DEFAULT;
#endif

    viafbinfo.pseudo_palette = pseudo_pal;
	  
    if(second_size && (second_size*1024*1024 >= (parinfo.memsize - (16*1024*1024))))
        second_size = (parinfo.memsize>>20) - 16;

    if(second_size && (second_size*1024*1024  <= (16*1024*1024)) )
        second_size = 16;

    if(second_size)
        second_offset = parinfo.memsize - second_size*1024*1024;	
    else
        second_offset = parinfo.memsize >> 1;
	 
    FB_MM=parinfo.fbmem_virt; 
    if(accel)
    {   /* Here we still use global variable parinfo. */
        Init_Accel();
        parinfo.accel = 1;
        Init_2D_Engine();
        HWCursorInit();
    }
#endif

    tmpm = mode;
    tmpc = strsep(&tmpm,"x");
    default_xres = simple_strtoul(tmpc,NULL,0);
    default_yres = simple_strtoul(tmpm,NULL,0);

    vmode_index = get_mode_index(default_xres, default_yres,0);
    DEBUG_MSG(KERN_INFO "0->index=%d\n", vmode_index );
  
     if(SAMM_ON==1)
     {
        if (strcmp(mode,mode1)){
           tmpm_sec = mode1;
           tmpc_sec= strsep(&tmpm_sec,"x");
           second_xres = simple_strtoul(tmpc_sec,NULL,0);
           second_yres = simple_strtoul(tmpm_sec,NULL,0);
       }else{
            second_xres=default_xres;
            second_yres=default_yres;
       }
        if(0 == second_virtual_xres)
        {
            switch(second_xres)
            {
                case 1400:
                    second_virtual_xres = 1408;
                    break;
                default:
                    second_virtual_xres = second_xres;
                    break;
            }
        }
        if(0 == second_virtual_yres)
        {
            second_virtual_yres = second_yres;
        }
    }

    switch (bpp) 
    {
        case 0 ... 8:
            bpp = 8;
            break;
        case 9 ... 16:
            bpp = 16;
            break;
        case 17 ... 32:
            bpp = 32;
            break;
        default :
            bpp = 8;
    }
    default_var.xres=default_xres;
    default_var.yres=default_yres;
    switch(default_xres)
    {
        case 1400:
            default_var.xres_virtual = 1408;
            break;
        default:
            default_var.xres_virtual=default_xres;
            break;
    }
    default_var.yres_virtual=default_yres;
    default_var.bits_per_pixel=bpp;
    if (default_var.bits_per_pixel==15)
        default_var.bits_per_pixel=16;
    default_var.pixclock=get_pixclock(default_xres, default_yres, refresh);
    default_var.left_margin=(default_xres>>3)&0xf8;
    default_var.right_margin=32;
    default_var.upper_margin=16;
    default_var.lower_margin=4;
    default_var.hsync_len=default_var.left_margin;
    default_var.vsync_len=4;
    default_var.accel_flags = 0;
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    if(dual_fb) 
    { 
    /* For dual-fb, apart the fb memory according to second_offset. */
    /* Not use second_size, it will be overload by others. */
         viafbinfo1 = viafbinfo;
         viafbinfo1.memsize = viafbinfo.memsize-second_offset;
         viafbinfo.memsize = second_offset;
         viafbinfo1.fbmem_virt = viafbinfo.fbmem_virt+second_offset;
         viafbinfo1.fbmem = viafbinfo.fbmem+second_offset;
         disp1 = disp;
         disp1.screen_base = viafbinfo1.fbmem_virt;
         viafbinfo1.gen.info.disp = &disp1;
         viafbinfo1.gen.info.screen_base = (char *)viafbinfo1.fbmem_virt;

         default_var.xres=second_xres;
         default_var.yres=second_yres;
         default_var.xres_virtual=second_virtual_xres;
         default_var.yres_virtual=second_virtual_yres;
         /* When dual-fb, have same bpp. */
         if(bpp1!=bpp) bpp1=bpp;
         default_var.bits_per_pixel=bpp1;
         default_var.pixclock=get_pixclock(second_xres, second_yres, refresh);
         default_var.left_margin=(second_xres>>3)&0xf8;
         default_var.right_margin=32;
         default_var.upper_margin=16;
         default_var.lower_margin=4;
         default_var.hsync_len=default_var.left_margin;
         default_var.vsync_len=4;
         via_decode_var(&default_var, &viafbinfo1.currentmode, &viafbinfo1.gen);

         fbgen_get_var(&disp1.var, -1, &viafbinfo1.gen.info);
    }
    via_decode_var(&default_var, &viafbinfo.currentmode, &viafbinfo.gen);
    fbgen_get_var(&disp.var, -1, &viafbinfo.gen.info);

#else
    viafbinfo.fix.accel = accel;
    parinfo.accel = accel; 
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
    if(accel) 
        viafbinfo.flags |= (FBINFO_HWACCEL_COPYAREA|FBINFO_HWACCEL_FILLRECT|FBINFO_HWACCEL_IMAGEBLIT);
    else
        viafbinfo.flags |= FBINFO_HWACCEL_DISABLED;
#else
    if(accel)
        default_var.accel_flags |= FB_ACCELF_TEXT;
    else
        default_var.accel_flags &= ~FB_ACCELF_TEXT;
#endif
    if(dual_fb) 
    {
    /* For dual-fb, apart the fb memory according to second_offset. */
    /* Not use second_size, it will be overload by others. */
         parinfo1 = parinfo;
         parinfo1.memsize = parinfo.memsize-second_offset;
         parinfo.memsize = second_offset;
         parinfo1.fbmem_virt = parinfo.fbmem_virt+second_offset;
         parinfo1.fbmem = parinfo.fbmem+second_offset;

         parinfo1.fbmem_used = parinfo.fbmem_used; /* used mem locate at tail */
         parinfo1.fbmem_free = parinfo1.memsize-parinfo1.fbmem_used; 
         parinfo.fbmem_free = parinfo.memsize;
         parinfo.fbmem_used = 0;
         if(accel) {
             parinfo1.cursor_start = parinfo.cursor_start - second_offset;
             parinfo1.VQ_start = parinfo.VQ_start - second_offset;
             parinfo1.VQ_end = parinfo.VQ_end - second_offset;
         }

         viafbinfo1 = viafbinfo;
         viafbinfo1.screen_base = viafbinfo.screen_base+second_offset;
         viafbinfo1.fix.smem_start = parinfo1.fbmem;
         viafbinfo1.fix.smem_len = parinfo1.fbmem_free;
         viafbinfo1.par = &parinfo1;

         default_var.xres=second_xres;
         default_var.yres=second_yres;
         default_var.xres_virtual=second_virtual_xres;
         default_var.yres_virtual=second_virtual_yres;
         /* When dual-fb, have same bpp. */
         if(bpp1!=bpp) bpp1=bpp;
         default_var.bits_per_pixel=bpp1;
         default_var.pixclock=get_pixclock(second_xres, second_yres, refresh);
         default_var.left_margin=(second_xres>>3)&0xf8;
         default_var.right_margin=32;
         default_var.upper_margin=16;
         default_var.lower_margin=4;
         default_var.hsync_len=default_var.left_margin;
         default_var.vsync_len=4;

         viafb_check_var(&default_var, &viafbinfo1);
         parinfo1.var = default_var;
         viafbinfo1.var = parinfo1.var;
         viafb_get_fix(&viafbinfo1.fix, &viafbinfo1);
    }

    viafbinfo.fix.smem_start = parinfo.fbmem;
    viafbinfo.fix.smem_len = parinfo.fbmem_free;
    viafb_check_var(&default_var, &viafbinfo);
    parinfo.var = default_var;
    viafbinfo.var = parinfo.var;
    viafb_get_fix(&viafbinfo.fix, &viafbinfo);
#endif

    default_var.activate = FB_ACTIVATE_NOW;

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    fbgen_set_disp(-1, &viafbinfo.gen);
    if(dual_fb) {
        fbgen_set_disp(-1, &viafbinfo1.gen);
    }
    via_loadpalette(&viafb_256_colors);

    if(dual_fb && (primary_dev==LCD_Device) && (chip_info.gfx_chip_name==UNICHROME_CLE266)) {
    /* When we want LCD be the primary device:  */
    /*   1. CLE266 IGA1 have some limitations to light LCD; */
    /*   2. IGA1(not only CLE266's) starting address is limited to 32M; */
    /* So the primary device LCD will still use IGA2, see hw.c:set_iga_path, */
    /* IGA1 have to point to firt frame buffer, IGA2 point to the second. */

    /* Here we firstly register viafbinfo1 which point second frame buffer, */
    /* this will create the /dev/fb0, used by LCD as primary device. */
         if(register_framebuffer(&viafbinfo1.gen.info)<0) { 
              printk("Could not register Via framtebuffer0\n");
              return -EINVAL;
         }
    }

    if (register_framebuffer(&viafbinfo.gen.info) < 0) {
        printk("Could not register Via framebuffer\n");
        return -EINVAL;
    }

    if(dual_fb && ((primary_dev!=LCD_Device) || (chip_info.gfx_chip_name!=UNICHROME_CLE266))) {
         if(register_framebuffer(&viafbinfo1.gen.info)<0) {
              printk("Could not register Via framebuffer1\n");
              return -EINVAL;
         }
    }

    DEBUG_MSG(KERN_INFO "fb%d: %s frame buffer device %dx%d-%dbpp\n",
       GET_FB_IDX(viafbinfo.gen.info.node), viafbinfo.gen.info.modename,default_var.xres,
       default_var.yres,default_var.bits_per_pixel);
#else
    viafbinfo.cmap = viafb_256_colors;

    if(dual_fb && (primary_dev==LCD_Device) && (chip_info.gfx_chip_name==UNICHROME_CLE266)) {
    /* viafbinfo1 as /dev/fb0, use IGA2. */
         if(register_framebuffer(&viafbinfo1)<0) {
              printk("Could not register Via framtebuffer0\n");
              return -EINVAL;
         }
    }

    if (register_framebuffer(&viafbinfo) < 0) {
        printk("Could not register Via framebuffer\n");
        return -EINVAL;
    }

    if(dual_fb && ((primary_dev!=LCD_Device) || (chip_info.gfx_chip_name!=UNICHROME_CLE266))) {
         if(register_framebuffer(&viafbinfo1)<0) {
              printk("Could not register Via framebuffer1\n");
              return -EINVAL;
         }
    }
    
    DEBUG_MSG(KERN_INFO "fb%d: %s frame buffer device %dx%d-%dbpp\n",
       viafbinfo.node, viafbinfo.fix.id,default_var.xres,
       default_var.yres,default_var.bits_per_pixel);
    
    /* Create proc entry */
    viafb_init_proc(parinfo.proc_entry);
#endif

#if defined FC5_2_6_15
    acquire_console_sem();
    viafbinfo.flags |= FBINFO_MISC_USEREVENT;
    fb_set_var(&viafbinfo, &default_var);
    viafbinfo.flags &= ~FBINFO_MISC_USEREVENT;
    release_console_sem();
#endif

    init_dac(IGA2); 
    return 0;
}

static void __devexit via_pci_remove(void)
{
    DEBUG_MSG(KERN_INFO "via_pci_remove!\n" );

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    unregister_framebuffer(&viafbinfo.gen.info);
    if(dual_fb) {
         unregister_framebuffer(&viafbinfo1.gen.info);
    }
    iounmap((void *)viafbinfo.fbmem_virt);

    /* Add for VT3324 Integrated TV. */
    if (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV)
    {
        iounmap((void *)viafbinfo.integrated_tv_map_base);
    }
    
#else
    unregister_framebuffer(&viafbinfo);
    if(dual_fb) {
         unregister_framebuffer(&viafbinfo1);
    }
    iounmap((void *)parinfo.fbmem_virt);

    /* Add for VT3324 Integrated TV. */
    if (chip_info.tv_chip_info.tv_chip_name == INTEGRATED_TV)
    {
        iounmap((void *)parinfo.integrated_tv_map_base);
    }
    
    /* remove proc entry */
    viafb_remove_proc(parinfo.proc_entry);
#endif
}

int __init viafb_init(void)
{
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,8)
#ifndef MODULE
    char *option = NULL;

    if (fb_get_options("viafb", &option))
        return -ENODEV;
    viafb_setup(option);
#endif
#endif

    DEBUG_MSG(KERN_INFO "viafb_init!\n" );
    printk(KERN_INFO "VIA Graphics Intergration Chipset framebuffer %d.%d initializing\n", VERSION_MAJOR, VERSION_MINOR);

    return via_pci_probe();
}

void __exit viafb_exit(void)
{
    DEBUG_MSG(KERN_INFO "viafb_exit!\n" );
    via_pci_remove();
    /* pci_unregister_driver(&viafb_pci_driver); */
}


/*
 * Parse user specified options (`video=viafb:')
 * example:
 *  video=viafb:mode=800x600,bpp=16,refresh=60,CRT:ON,TV:ON
 */
int __init viafb_setup(char *options)
{
    char *this_opt;
	
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
	viafbinfo.gen.info.fontname[0] = '\0';
#endif
    
    DEBUG_MSG(KERN_INFO "viafb_setup!\n" );
    
    if (!options || !*options)
		return 0;

    while ((this_opt = strsep(&options, ",")) != NULL) {
    	if (!*this_opt) continue;

    	if (!strncmp(this_opt, "mode=", 5)){
           mode = kmalloc(strlen(this_opt+4), GFP_KERNEL);    
    	    strcpy(mode, this_opt+5);
        }
    	else if (!strncmp(this_opt, "mode1=", 6)){
           mode1 = kmalloc(strlen(this_opt+5), GFP_KERNEL);  
    	    strcpy(mode1, this_opt+6);
       }
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    	else if (!strncmp(this_opt, "font:", 5)){
           viafbinfo = kmalloc(strlen(this_opt+4), GFP_KERNEL);  
           strcpy(viafbinfo.gen.info.fontname, this_opt+5);
       }
#endif

    	else if (!strncmp(this_opt, "bpp=", 4))
    	{
            bpp = simple_strtoul(this_opt+4, NULL, 0);
    	}
        else if (!strncmp(this_opt, "bpp1=", 5))
        {
    	    bpp1 = simple_strtoul(this_opt+5, NULL, 0);
    	}	 
    	else if (!strncmp(this_opt, "refresh=", 8))
    	{
    	    refresh = simple_strtoul(this_opt+8, NULL, 0);
    	}
        else if (!strncmp(this_opt, "refresh1=", 9))
        {
    	    refresh1 = simple_strtoul(this_opt+9, NULL, 0);
    	}	
    	else if (!strncmp(this_opt, "lcd_dsp_method=", 15))
    	{
    	    lcd_dsp_method = simple_strtoul(this_opt+15, NULL, 0);
    	}		
    	else if (!strncmp(this_opt, "lcd_panel_id=", 13))
    	{
    	    lcd_panel_id = simple_strtoul(this_opt+13, NULL, 0);			 	 
    	}
        else if (!strncmp(this_opt, "tv_system=", 10))        
        {
            tv_system = simple_strtoul(this_opt+10, NULL, 0);            
        }
    	else if (!strncmp(this_opt, "tv_level=", 9))
    	{
    	    tv_level = simple_strtoul(this_opt+9, NULL, 0);
        }
        else if (!strncmp(this_opt, "tv_out_signal=", 14))        
        {
            tv_out_signal = simple_strtoul(this_opt+14, NULL, 0);           
        }
    	else if (!strncmp(this_opt, "tv_dedotcrawl=", 14))
    	{
    	    tv_dedotcrawl = simple_strtoul(this_opt+14, NULL, 0);
        }
    	else if (!strncmp(this_opt, "tv_ffilter=", 11))
    	{
    	    tv_tint = simple_strtoul(this_opt+11, NULL, 0);
    	}
    	else if (!strncmp(this_opt, "tv_brightness=", 14))
    	{
    	    tv_brightness = simple_strtoul(this_opt+14, NULL, 0);
    	}			
    	else if (!strncmp(this_opt, "tv_contrast=", 12))
    	{
    	    tv_contrast = simple_strtoul(this_opt+12, NULL, 0);
    	}			
    	else if (!strncmp(this_opt, "tv_saturation=", 14))
    	{
    	    tv_saturation = simple_strtoul(this_opt+14, NULL, 0);
    	}			
    	else if (!strncmp(this_opt, "tv_tint=", 8))
    	{
    	    tv_tint = simple_strtoul(this_opt+8, NULL, 0);
    	}
    	else if (!strncmp(this_opt, "accel=", 6))
    	{
    	    accel = simple_strtoul(this_opt+6, NULL, 0);
    	}			
    	else if (!strncmp(this_opt, "SAMM:", 5))
    	{
    	    if (!strncmp(this_opt+5, "ON", 2))
    	        SAMM_ON=1;
    	}
        else if (!strncmp(this_opt, "active_dev=", 11))
        {
            active_dev = kmalloc(strlen(this_opt+10), GFP_KERNEL);  
            strcpy(active_dev, this_opt+11);
        }
        else if (!strncmp(this_opt, "display_hardware_layout=", 24))
        {
            display_hardware_layout = simple_strtoul(this_opt+24, NULL, 0);
        }
        else if (!strncmp(this_opt, "second_size=", 12))
        {
            second_size = simple_strtoul(this_opt+12, NULL, 0);
        }
        else if (!strncmp(this_opt, "EPIA_DVI", 9))
        {
            EPIA_DVI = simple_strtoul(this_opt+9, NULL, 0);                
        }
        else if (!strncmp(this_opt, "LCDDualEdge=", 12))       
        {
            LCDDualEdge = simple_strtoul(this_opt+12, NULL, 0);
        }
        else if (!strncmp(this_opt, "BusWidth=", 9))
        {
            BusWidth = simple_strtoul(this_opt+9, NULL, 0);  
        }
        else if (!strncmp(this_opt, "lcd_mode=", 9))                          		
        {
            lcd_mode = simple_strtoul(this_opt+9, NULL,0);        
        }
        else if (!strncmp(this_opt, "video_dev=", 10))                          		
        {
            video_dev = kmalloc(strlen(this_opt+9), GFP_KERNEL);  
            strcpy(video_dev, this_opt+10);
        }
        else if(!strncmp(this_opt, "lcd_port=", 9))
        {
            lcd_port = kmalloc(strlen(this_opt+8), GFP_KERNEL);  
            strcpy(lcd_port, this_opt+9);
        }
        else if(!strncmp(this_opt, "tv_port=", 8))
        {
            tv_port = kmalloc(strlen(this_opt+7), GFP_KERNEL);  
            strcpy(tv_port, this_opt+8);
        }
    }	    
    return 0;
}



#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
static struct fb_ops viafb_ops = {
    fb_get_fix:fbgen_get_fix,
    fb_get_var:fbgen_get_var,
    fb_set_var:fbgen_set_var,
    fb_get_cmap:fbgen_get_cmap,
    fb_set_cmap:fbgen_set_cmap,
    fb_pan_display:fbgen_pan_display,
    fb_ioctl:viafb_ioctl,
};
#else
static struct fb_ops viafb_ops = {
    .owner        = THIS_MODULE,
    .fb_open      = viafb_open,
    .fb_release   = viafb_release,
    .fb_check_var = viafb_check_var,
    .fb_set_par   = viafb_set_par,
    .fb_setcolreg = viafb_setcolreg,
    .fb_pan_display = viafb_pan_display,
    .fb_blank     = viafb_blank,
    .fb_fillrect  = viafb_fillrect,
    .fb_copyarea  = viafb_copyarea,
    .fb_imageblit = viafb_imageblit,
    .fb_cursor    = viafb_cursor,
    .fb_ioctl     = viafb_ioctl,
    .fb_sync      = viafb_sync,
#if LINUX_VERSION_CODE > KERNEL_VERSION(2,6,10)
    .fb_setcmap   = viafb_setcmap,
#endif
};
#endif

module_init(viafb_init);
module_exit(viafb_exit);
#ifdef MODULE

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (memsize,int,0);
module_param (mode,charp,0);
#else
MODULE_PARM(memsize,"i");
MODULE_PARM(mode,"s");
#endif
MODULE_PARM_DESC(mode, "Set resolution (default=640x480)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (mode1,charp,0);
#else
MODULE_PARM(mode1,"s");
#endif
MODULE_PARM_DESC(mode1, "Set resolution (default=640x480)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (bpp,int,0);
#else
MODULE_PARM(bpp,"i");
#endif
MODULE_PARM_DESC(bpp, "Set color depth (default=32bpp)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (bpp1,int,0);
#else
MODULE_PARM(bpp1,"i");
#endif
MODULE_PARM_DESC(bpp1, "Set color depth (default=32bpp)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (refresh,int,0);
#else
MODULE_PARM(refresh,"i");
#endif
MODULE_PARM_DESC(refresh, "Set CRT refresh rate (default = 60)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (refresh1,int,0);
#else
MODULE_PARM(refresh1,"i");
#endif
MODULE_PARM_DESC(refresh1, "Set CRT refresh rate (default = 60)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_system,int,0);
#else
MODULE_PARM(tv_system, "i");
#endif
MODULE_PARM_DESC(tv_system, "TV Signal Standard (NTSC, PAL,...,etc)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_level,int,0);
#else
MODULE_PARM(tv_level, "i");
#endif
MODULE_PARM_DESC(tv_level, "TV Horizontal/Vertical Contraction Control");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_out_signal,int,0);
#else
MODULE_PARM(tv_out_signal, "i");
#endif
MODULE_PARM_DESC(tv_out_signal, "Set TV output signal.(Default=Composite+SVideo)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_dedotcrawl,int,0);
#else
MODULE_PARM(tv_dedotcrawl, "i");
#endif
MODULE_PARM_DESC(tv_dedotcrawl, "Control TV DeDotCrawl function.(Default=disable)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_ffilter,long,0);
#else
MODULE_PARM(tv_ffilter, "l");
#endif
MODULE_PARM_DESC(TV_ffilter, "Set TV Flicker Filter level");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_brightness,long,0);
#else
MODULE_PARM(tv_brightness, "l");
#endif
MODULE_PARM_DESC(TV_brightness, "Set TV output brightness");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_contrast,long,0);
#else
MODULE_PARM(tv_contrast, "l");
#endif
MODULE_PARM_DESC(TV_contrast, "Set TV output contrast");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_saturation,long,0);
#else
MODULE_PARM(tv_saturation, "l");
#endif
MODULE_PARM_DESC(TV_saturation, "Set TV output saturation");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_tint,long,0);
#else
MODULE_PARM(tv_tint, "l");
#endif
MODULE_PARM_DESC(TV_tint, "Set TV output tint");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (lcd_panel_id,int,0);
#else
MODULE_PARM(lcd_panel_id, "i");
#endif
MODULE_PARM_DESC(lcd_panel_id, "Set Flat Panel type(Default=1024x768)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (lcd_dsp_method,int,0);
#else
MODULE_PARM(lcd_dsp_method, "i");
#endif
MODULE_PARM_DESC(lcd_dsp_method, "Set Flat Panel display scaling method.(Default=Expandsion)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (SAMM_ON,int,0);
#else
MODULE_PARM(SAMM_ON, "i");
#endif
MODULE_PARM_DESC(SAMM, "Turn on/off flag of SAMM(Default=OFF)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (accel,int,0);
#else
MODULE_PARM(accel, "i");
#endif
MODULE_PARM_DESC(accel, "Set 2D Hardware Acceleration.(Default = OFF)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (active_dev,charp,0);
#else
/* Added for specifying active devices. */
MODULE_PARM(active_dev, "s");
#endif
MODULE_PARM_DESC(active_dev, "Specify active devices.");
/* Added for specifying display hardware layout. */
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (display_hardware_layout,int,0);
#else
MODULE_PARM(display_hardware_layout, "i");
#endif
MODULE_PARM_DESC(display_hardware_layout, "Display Hardware Layout (LCD Only, DVI Only...,etc)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (second_size,int,0);
#else
MODULE_PARM(second_size, "i");
#endif
MODULE_PARM_DESC(second_size, "Set secondary device memory size");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (dual_fb,int,0);
#else
MODULE_PARM(dual_fb, "i");
#endif
MODULE_PARM_DESC(dual_fb, "Turn on/off flag of dual framebuffer devices.(Default = OFF)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (EPIA_DVI,int,0);
#else
/* Add for support DVI on EPIA-M */
MODULE_PARM(EPIA_DVI, "i");
#endif
MODULE_PARM_DESC(EPIA_DVI, "Turn on/off flag of DVI devices on EPIA board.(Default = OFF)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (LCDDualEdge,int,0);
#else
MODULE_PARM(LCDDualEdge, "i");
#endif
MODULE_PARM_DESC(LCDDualEdge, "Turn on/off flag of dual edge panel.(Default = OFF)");
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (BusWidth,int,0);
#else
MODULE_PARM(BusWidth, "i");
#endif
MODULE_PARM_DESC(BusWidth, "Set bus width of panel.(Default = 12)");

/* for Panel mode: OPENLDI or SPWG */
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (lcd_mode,int,0);
#else
MODULE_PARM(lcd_mode, "i");
#endif
MODULE_PARM_DESC(lcd_mode, "Set Flat Panel mode(Default=OPENLDI)");

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (video_dev,charp,0);
#else
/* Added for specifying active devices. */
MODULE_PARM(video_dev, "s");
#endif
MODULE_PARM_DESC(video_dev, "Specify video devices.");

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (lcd_port,charp,0);
#else
MODULE_PARM(lcd_port, "s");
#endif
MODULE_PARM_DESC(lcd_port, "Specify LCD output port.");

/* Add to specify the TV output port. */
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (tv_port,charp,0);
#else
MODULE_PARM(tv_port, "s");
#endif
MODULE_PARM_DESC(tv_port, "Specify TV output port.");

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
module_param (dvi_port,charp,0);
#else
MODULE_PARM(dvi_port, "s");
#endif
MODULE_PARM_DESC(dvi_port, "Specify DVI output port.");

#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,9)
    MODULE_LICENSE("GPL");
#endif

#endif


